function B = basicqr(A,iter)               %last updated 3/26/00
%BASICQR   Apply the basic qr method to matrix A iter times.
%
%   Use in the form ==>  basicqr(A,iter)  <==
%
%   There are choices for various display options.  
%
% By: David R. Hill, Math Dept, Temple University,
%     Philadelphia, Pa. 19122   Email: dhill001@temple.edu
%  
mess = 'Press ENTER for the next approximation.';
s0=' ';
options=['1. See a movie of the reduction process   ';
         '   with a short pause after each iterate. ';
         '                                          ';
         '2. See the sequence of iterates one at a  ';
         '   time. Press ENTER to see the next one. ';
         '                                          ';
         '3. See the matrices Q and R that generate ';
         '   each approximation.                    ';
         '                                          ';
         '4. See just the final result.             ';
         '                                          ';
         '0. QUIT.                                  ';
         '                                          ';
         '                                          '];
choice='     Enter your choice ==>  ';
tryit='Improper response; Try again.';
press='Press ENTER to CONTINUE.';

%BEGIN

[m n]=size(A);
if m~=n
   disp('ERROR: Matrix is not square.')
   return
end
Aorig=A;

allA=A;
for j=1:iter   %Computes the approximation
    [Q,R]=qr(A);
    A=R*Q;
    allA=[allA A]; %Stores stp-by-step in allA
end
B=A;  %the final approximation   
sig='N';
while sig =='N'
   A=Aorig;
   format compact   
   clc
   disp('BASIC QR-METHOD for Eigenvalue Approximation:')
   disp(s0)
   disp('Original matrix is A') 
   disp(s0)
   disp(Aorig);
   disp(s0)
   disp(options)
   resp=input(choice);
   if isempty(resp),resp=99;end
   if resp==0,format,return,end
   if resp==3
      allA=A;
      for j=1:iter
         [Q,R]=qr(A)
         disp(['A' num2str(j) ' ='])
         A=R*Q;disp(A)
         disp(mess)
         pause,clc   
         allA=[allA A];
      end
   end
   if resp==1 | resp==2
      for j=1:iter+1
          clc,disp(['A' num2str(j-1) ' = ']),
          disp(allA(:,(j-1)*n+1:j*n))
          if resp==1
             pause(2)
          else
             disp(press),pause
          end
      end
   end
   if resp==4
      clc
      disp('BASIC QR-METHOD for Eigenvalue Approximation:')
      disp(s0)
      disp(['The final approximation A' num2str(iter) ' is']) 
      disp(s0)
      disp(B);
      disp(press),pause
   end   
   if resp~=0 & resp~=1 & resp~=2 & resp~=3 & resp~=4
      disp(tryit),disp(press),pause
   end
end





                                                          
                                                             

                                    