function C = circ(a)                %last updated 8/14/98
%CIRC  Form a circulant matrix from vector a.
%
%      Use in the form  --> C = circ(a) <--
%
%      By: David R. Hill, MATH Dept., Temple University,
%          Philadelphia, Pa. 19122
n=length(a);
C=eye(n)*a(1);
for i = 2:n
   x=ones(1,n+1-i);
   C = C + a(i)*diag(x,i-1) + a(n+2-i)*diag(x,1-i);
end
