%dethaveit  Used as part of detrecur routine.            9/15/98
%           Called from dmincalc to process the entered
%           value of the determinant of a minor.
%
%           Action: If a value of the det of a minor is correct
%           this routine inserts it into the det(A) display
%           on the main screen. When all four have been entered
%           correctly it also creates an entry field on the main
%           screen for the final value of the det(A).
%
%  By: David R. Hill, Mathematics Dept., Temple Univ.
%      Philadelphia, PA. 19122    Email: dhill001@temple.edu

if abs(detvalB-detB)<10*eps
   whichdone(butpushed)=1;
   mess1='Det value is CORRECT.';
   mess2=' ';
   set(txtHndlm,'string',mess1,...
   'fontweight','bold','fontsize',16);
   set(txtHndlm1,'string',mess2,...
    'fontweight','bold','fontsize',14);
   pause(3);
   close(gcf);
   delete(bigdisp);detdisp='det(A) = ';
   if expmode=='R'
      partname1=['det(M(' num2str(expnum) ',' num2str(1) '))'];
      partname2=['det(M(' num2str(expnum) ',' num2str(2) '))'];
      partname3=['det(M(' num2str(expnum) ',' num2str(3) '))']; 
      partname4=['det(M(' num2str(expnum) ',' num2str(4) '))'];   
      
      if whichdone(1)==1;partname1=['(' num2str(valsofminors(1)) ')'];end
      if whichdone(2)==1;partname2=['(' num2str(valsofminors(2)) ')'];end
      if whichdone(3)==1;partname3=['(' num2str(valsofminors(3)) ')'];end
      if whichdone(4)==1;partname4=['(' num2str(valsofminors(4)) ')'];end

      detdisp=[detdisp '(' num2str(A(expnum,1)) ')*' partname1];
      detdisp=[detdisp sgn(2,:) '(' num2str(A(expnum,2)) ')*' partname2];
      detdisp=[detdisp sgn(3,:) '(' num2str(A(expnum,3)) ')*' partname3]; 
      detdisp=[detdisp sgn(4,:) '(' num2str(A(expnum,4)) ')*' partname4];
   else
      partname1=['det(M(' num2str(1) ',' num2str(expnum) '))'];
      partname2=['det(M(' num2str(2) ',' num2str(expnum) '))'];
      partname3=['det(M(' num2str(3) ',' num2str(expnum) '))'];
      partname4=['det(M(' num2str(4) ',' num2str(expnum) '))'];
      
      if whichdone(1)==1;partname1=['(' num2str(valsofminors(1)) ')'];end
      if whichdone(2)==1;partname2=['(' num2str(valsofminors(2)) ')'];end
      if whichdone(3)==1;partname3=['(' num2str(valsofminors(3)) ')'];end
      if whichdone(4)==1;partname4=['(' num2str(valsofminors(4)) ')'];end

      detdisp=[detdisp '(' num2str(A(1,expnum)) ')*' partname1];
      detdisp=[detdisp sgn(2,:) '(' num2str(A(2,expnum)) ')*' partname2];
      detdisp=[detdisp sgn(3,:) '(' num2str(A(3,expnum)) ')*' partname3];
      detdisp=[detdisp sgn(4,:) '(' num2str(A(4,expnum)) ')*' partname4];
   end

   bigdisp=text(0,.5,detdisp,'color','r',...
       'fontweight','bold','fontsize',12);
   if butpushed==1;delete(min1but);end
   if butpushed==2;delete(min2but);end
   if butpushed==3;delete(min3but);end
   if butpushed==4;delete(min4but);end
   if mtotal==4,delete(minbutfrm);alldone='Y';else,alldone='N';end

else
   
   mess1='Det value is INCORRECT.';
   mess2='Redo calculaution and reenter.';
   set(txtHndlm,'string',mess1,...
   'fontweight','bold','fontsize',16);
   set(txtHndlm1,'string',mess2,...
    'fontweight','bold','fontsize',14);
   set(detval,'string',' ');
end

fhavdet='fdetvalA=get(fdetval,''string'');';
fhavdet=[fhavdet 'compval=str2num(fdetvalA);if truval==compval,'];
fhavdet=[fhavdet 'set(txtHndl,''string'',''det(A) is CORRECT.'','];
fhavdet=[fhavdet '''fontweight'',''bold'',''fontsize'',16);'];
fhavdet=[fhavdet 'set(txtHndl1,''string'',''Click on a button to proceed.'','];
fhavdet=[fhavdet '''fontweight'',''bold'',''fontsize'',14);'];
fhavdet=[fhavdet 'else,set(txtHndl,''string'',''det(A) is INCORRECT.'','];
fhavdet=[fhavdet '''fontweight'',''bold'',''fontsize'',16);'];
fhavdet=[fhavdet 'set(txtHndl1,''string'',''TRY again.'','];
fhavdet=[fhavdet '''fontweight'',''bold'',''fontsize'',16);'];
fhavdet=[fhavdet 'set(fdetval,''string'','' '');'];
fhavdet=[fhavdet 'end'];

if alldone=='Y'  %all four dets of minors done correctly
   finaldet=subplot('position',[.55 .15 .1 .15]);axis('off');
   fdetdisp='det(A) = ';
   text(0,.4,fdetdisp,'color','r','fontweight','bold','fontsize',16);
   fdetval=uicontrol('Style','edit','units','normal',...
           'position',[.7 .18 .1 .08],'back','y','fontsize',16,...
           'fontweight','bold','HorizontalAlignment','left',...
           'call', 'eval(fhavdet)');
   set(txtHndl,'string','Compute det(A). Click in the yellow',...
               'fontweight','bold','fontsize',14);
   set(txtHndl1,'string','box, type the value, and press Enter.',...
                'fontweight','bold','fontsize',12); 
   truval=det(A);
end



   