%DETMINOR   Called by dispmin to as part of detrecur.   9/15/98
%           Sets up buttons for computation of minors
%           along with appropriate messages. It computes
%           the minors and names them for future use.
%           The values of the determinants of the 4 minors
%           is computed and stored for later use.
%
%           ACTION:
%           As a button for a minor is pushed routine
%           dmincalc is called to process the computation
%           of the determinant of a minor.
%
%  By: David R. Hill, Mathematics Dept., Temple Univ.
%      Philadelphia, PA. 19122    Email: dhill001@temple.edu

mline1=['Click on a button to compute'];
mline2=['the determinant of the minor.'];
set(txtHndl,'string',mline1,...
       'fontweight','bold','fontsize',14);
set(txtHndl1,'string',mline2,...
       'fontweight','bold','fontsize',14);

if expmode=='R'
   sub1=expnum*ones(1,4);sub2=[1:4];
else
   sub2=expnum*ones(1,4);sub1=[1:4];
end

% button labels 
min1label=['det(M(' num2str(sub1(1)) ',' num2str(sub2(1)) '))']; 
min2label=['det(M(' num2str(sub1(2)) ',' num2str(sub2(2)) '))'];
min3label=['det(M(' num2str(sub1(3)) ',' num2str(sub2(3)) '))'];
min4label=['det(M(' num2str(sub1(4)) ',' num2str(sub2(4)) '))'];
 
%Compute the minors & save them for use
for jj=1:4
    rvals=1:matsize;cvals=rvals;
    if expmode=='R'
       rk=expnum;ck=jj;
    else
       rk=jj;ck=expnum;
    end
    rvals(rk)=200;cvals(ck)=200;
    rvals=sort(rvals);cvals=sort(cvals);
    rvals=rvals(1:matsize-1);cvals=cvals(1:matsize-1);
    minmat=A(rvals,cvals);
    if jj==1,M1=minmat;end
    if jj==2,M2=minmat;end
    if jj==3,M3=minmat;end
    if jj==4,M4=minmat;end
end

valsofminors=[det(M1) det(M2) det(M3) det(M4)];

%buttons for computing det of minors
minbutfrm=uicontrol('style','frame','units','normal',...
                 'position',[.64 .04 .15 .23],'backgroundcolor','c');

min1but = uicontrol('style','push','units','normal','pos',[.65 .2 .13 .04], ...
        'string',min1label,'fontweight','bold','fontsize',12,...
        'call','B=M1;name=min1label;butpushed=1;mtotal=mtotal+1;dmincalc');

min2but = uicontrol('style','push','units','normal','pos',[.65 .15 .13 .04], ...
        'string',min2label,'fontweight','bold','fontsize',12,...
        'call','B=M2;name=min2label;butpushed=2;mtotal=mtotal+1;dmincalc');

min3but = uicontrol('style','push','units','normal','pos',[.65 .1 .13 .04], ...
        'string',min3label,'fontweight','bold','fontsize',12,...
        'call','B=M3;name=min3label;butpushed=3;mtotal=mtotal+1;dmincalc');

min4but = uicontrol('style','push','units','normal','pos',[.65 .05 .13 .04], ...
        'string',min4label,'fontweight','bold','fontsize',12,...
        'call','B=M4;name=min4label;butpushed=4;mtotal=mtotal+1;dmincalc');

