%DETRECUR  Demonstration of recursive computation of determinants. 3/29/00
%          The determinant of a 4 by 4 matrix A is expressed as a
%          linear combination of 3 by 3 determinants of submatrices.
%          The user chooses the mode of expansion, row or column,
%          and the number of the row or column to expand about. 
%          Each submatrix (minor) used is explicitly shown along with
%          the approriate coefficient to form the linear combination.
%          It is optional to proceed to compute the determinants of
%          the minors. If you choose to do so, computational aids for
%          the 3 by 3 device and recursive computation are available. 
%          The value of the determinant of a minor is checked, and
%          when correct is inserted in the expression for det(A).
%          When all four determinants of the minors involved are
%          computed the value of det(A) can be entered and checked.
%
%          This is a demonstration tool but it can be used in an
%          exploratory manner by students. It is restricted to 
%          4 by 4 matrices with single digit entries (positive
%          negative, or zero). This simplifies the representation 
%          of matrices for screen display at a number of stages 
%          of the routine.
%
%          Use in the form   ==>  detrecur  <==
%
%          This routine requires a number of other m-files:
%               mat2strh, dethaveit, drecurm, detminor, dispmin
%               dmincalc, outline
%          Type this file for details on organization.
%
%  By: David R. Hill, Math Dept, Temple University,
%      Philadelphia, Pa. 19122   Email: dhill001@temple.edu

%ORGANIZATION comment: spaghetti code.
%Seven scripts that perform the action of Determinants, Recursively.
%      detrecur >calls outline to put frame boxes of color around the
%                matrix A which is a 4 by 4 array of buttons
%               >calls dispmin to display the minors, 3 by 3, matrices
%                on the 'main' figure
%
%      dispmin > calls outline and detminor
%
%      detminor > calls dmincalc
%
%      dmincalc > calls dethaveit and drecurm
%      
%See the individual help files for a brief descrition of each routine.


%STRINGS
%
dummy=' ';
header='Determinants, RECURSIVELY';
cont='Press ENTER to continue.';
s0=' ';
s8='               ***** RECURSIVE Computation of a Determinant *****';
s10='     ENTER your choice ===> ';
s11='Press  ENTER  to continue';
s17=['You need to select an input matrix from the available demos';
     'or enter one of your own. If you opt to enter one of your  ';
     'own, it must be 4 by 4 with single digit integer entries   ';
     'which can be positive, negative, or zero.                  ';];

s18=['            <<OPTIONS>>                      ';
     '                                             ';
     ' <1> Select a matrix from the built-in demos.';
     '                                             ';
     ' <2> Enter your own matrix.                  ';
     '                                             ';
     ' <3> See a description of this routine.      ';
     '                                             ';
     ' <0> Quit.                                   '];

demomenu=['    Matrix #1             Matrix #2      ';
         '                                         ';
         '  4   2  -3   0         -9   6   7   2   ';
         '  0   1   5   7         -8   0   3   1   ';
         '  2   1   2   3          5  -4   0   2   ';
         '  0   5  -6  -1          6  -2  -7  -2   ';
         '                                         ';
         '    Matrix #3             Matrix #4      ';
         '                                         ';
         '  2  -1   3   5          1   2  -3   4   ';
         '  4   1   0   4          2  -3   4   1   ';
         '  6  -5   1   7         -3   4   1   2   ';
         '  1   0   0   1          4   1   2  -3   ';
         '                                         '];


%initializing
accesscnt=0;  %counting number of times we use dispmat
clry='y';     %color yellow
matsize=4;    %matrix size
mtotal=0;     %setting number of compute minor buttons pushed to zero
              %used in detminor and in have dethaveit
whichdone=[0 0 0 0]; %array for which minors are done
                     %used in dethaveit
alldone='N';
%Input: Five built in examples and enter your own.
%
gdcode='N';
   while gdcode=='N'
      clc,disp(s8),disp(s0)%disp(s17),disp(s0)
      disp(s18),disp(s0),ch=input(s10);
      if ch==0,clc,disp('DETRECUR is over!'),return,end
      if ch==3,clc,help detrecur,disp(s0),disp(cont),pause,end
      if ch==1,clc,disp(s8),disp(s0),disp(demomenu),disp(s0)
         democh=input(s10);
         if democh==1,A=[4 2 -3 0;0 1 5 7;2 1 2 3;0 5 -6 -1];gdcode='Y';end
         if democh==2,A=[-9 6 7 2; -8 0 3 1;5 -4 0 2;6 -2 -7 -1];gdcode='Y';end
         if democh==3,A=[2 -1 3 5;4 1 0 4;6 -5 1 7;1 0 0 1];gdcode='Y';end
         if democh==4,A=[1 2 -3 4;2 -3 4 1;-3 4 1 2;4 1 2 -3];gdcode='Y';end
      end
      if ch==2,gdcode='Y';clc,disp(s8),disp(s0)
         disp('Enter your matrix 4 by 4 matrix. Its entries must be')
         disp('single digit integers, positive or negative. Include the entries')
         disp('between square brackets [  ] .')
         disp(s0)
         A=input('   Your matrix A =   ');
         [mA,nA]=size(A);
         if mA~=4 | nA~=4, gdcode='N';disp('Matrix not 4 by 4.'),end
         absA=abs(A);
         for ik=1:mA
             for jk=1:nA
                 if length(num2str(absA(ik,jk)))~=1,gdcode='N';end
                 %if absA(ik,jk)>0 & absA(ik,jk)<1,gdcode='N';end
             end
         end
      end
      if ch~=3 & gdcode=='N',disp('Improper choice; TRY again.'),disp(s11),pause,end
   end
%END of input area


%callbacks
%
dummy=' ';
rowsel='expmode=''R'';delete(rowbut);delete(colbut);delete(rcbutfrm);eval(getnumber);';
colsel='expmode=''C'';delete(rowbut);delete(colbut);delete(rcbutfrm);eval(getnumber);';

done = 'close(gcf),clc,disp(''Routine detrecur is over.'')';
        %callback for quit button
%callback for the help button
helps='set(gcf,''visible'',''off'');clc,help detrecur,disp(cont),';
helps=[helps 'pause,set(gcf,''visible'',''on'');'];

%


%routines to be evaled
%
%what to do once we selected row or column mode for expansion
getnumber='if expmode==''R'',st=''Select Row Number'';else,st=''Select Column Number'';end,';
getnumber=[getnumber 'set(txtHndl,''string'',st,''fontweight'',''bold'',''fontsize'',14);'];
getnumber=[getnumber 'set(txtHndl1,''string'',''to expand about. '','];
getnumber=[getnumber '''fontweight'',''bold'',''fontsize'',14);'];
getnumber=[getnumber 'numbutfrm=uicontrol(''style'',''frame'',''units'',''normal'','];
getnumber=[getnumber '''position'',[.54 .09 .12 .21],''backgroundcolor'',''y'');'];
getnumber=[getnumber 'num1but = uicontrol(''style'',''push'',''units'',''normal'','];
getnumber=[getnumber '''pos'',[.55 .25 .1 .04],''string'',''1'',''fontweight'',''bold'','];
getnumber=[getnumber '''fontsize'',12,''call'',''expnum=1;eval(wipenums);'');'];
getnumber=[getnumber 'num2but = uicontrol(''style'',''push'',''units'',''normal'','];
getnumber=[getnumber '''pos'',[.55 .2 .1 .04],''string'',''2'',''fontweight'',''bold'','];
getnumber=[getnumber '''fontsize'',12,''call'',''expnum=2;eval(wipenums);'');'];
getnumber=[getnumber 'num3but = uicontrol(''style'',''push'',''units'',''normal'','];
getnumber=[getnumber '''pos'',[.55 .15 .1 .04],''string'',''3'',''fontweight'',''bold'','];
getnumber=[getnumber '''fontsize'',12,''call'',''expnum=3;eval(wipenums);'');'];
getnumber=[getnumber 'num4but = uicontrol(''style'',''push'',''units'',''normal'','];
getnumber=[getnumber '''pos'',[.55 .1 .1 .04],''string'',''4'',''fontweight'',''bold'','];
getnumber=[getnumber '''fontsize'',12,''call'',''expnum=4;eval(wipenums);'');'];

%WIPE OUT number buttons
%
wipenums='delete(num1but);delete(num2but);delete(num3but);delete(num4but);delete(numbutfrm);';
wipenums=[wipenums 'expmode1=expmode;loc=expnum;clr=''r'';outline;'];
wipenums=[wipenums 'set(txtHndl,''string'',''Generate the MINORS.'',''fontweight'',''bold'',''fontsize'',14);'];
wipenums=[wipenums 'if expmode==''R'',stmess=''Click on a column button.'';else,stmess=''Click on a row button.'';end,'];
wipenums=[wipenums 'set(txtHndl1,''string'',stmess,'];
wipenums=[wipenums '''fontweight'',''bold'',''fontsize'',14);'];
wipenums=[wipenums 'eval(minorgen);'];

%wipe out column labels
wipec='if cnum==1,delete(bc1);end;if cnum==2,delete(bc2);end;';
wipec=[wipec 'if cnum==3,delete(bc3);end;if cnum==4,delete(bc4);end;'];

%wipe out row labels
wiper='if cnum==1,delete(br1);end;if cnum==2,delete(br2);end;';
wiper=[wiper 'if cnum==3,delete(br3);end;if cnum==4,delete(br4);end;'];

%generate minors
%
minorgen=['if expmode==''R'','];
minorgen=[minorgen 'jj=1;pl=[xstart+(jj-1)*.06 ystart-.06 .03 .03];'];
minorgen=[minorgen 'bc1=uicontrol(''style'',''push'',''units'',''normal'',''pos'','];
minorgen=[minorgen 'pl,''string'',''C1'','];
minorgen=[minorgen '''fontweight'',''bold'',''fontsize'',10,'];
minorgen=[minorgen '''call'',''cnum=1;eval(wipec);dispmin'');'];
%minorgen=[minorgen 'dispmin'');'];

minorgen=[minorgen 'jj=2;pl=[xstart+(jj-1)*.06 ystart-.06 .03 .03];'];
minorgen=[minorgen 'bc2=uicontrol(''style'',''push'',''units'',''normal'',''pos'','];
minorgen=[minorgen 'pl,''string'',''C2'','];
minorgen=[minorgen '''fontweight'',''bold'',''fontsize'',10,'];
minorgen=[minorgen '''call'',''cnum=2;eval(wipec);dispmin'');'];

minorgen=[minorgen 'jj=3;pl=[xstart+(jj-1)*.06 ystart-.06 .03 .03];'];
minorgen=[minorgen 'bc3=uicontrol(''style'',''push'',''units'',''normal'',''pos'','];
minorgen=[minorgen 'pl,''string'',''C3'','];
minorgen=[minorgen '''fontweight'',''bold'',''fontsize'',10,'];
minorgen=[minorgen '''call'',''cnum=3;eval(wipec);dispmin'');'];

minorgen=[minorgen 'jj=4;pl=[xstart+(jj-1)*.06 ystart-.06 .03 .03];'];
minorgen=[minorgen 'bc4=uicontrol(''style'',''push'',''units'',''normal'',''pos'','];
minorgen=[minorgen 'pl,''string'',''C4'','];
minorgen=[minorgen '''fontweight'',''bold'',''fontsize'',10,'];
minorgen=[minorgen '''call'',''cnum=4;eval(wipec);dispmin'');'];

minorgen=[minorgen 'else,'];  %do the row labels

minorgen=[minorgen 'ii=1;pl=[xstart+(4)*.06 ystart+(4-ii)*.06 .03 .03];'];
minorgen=[minorgen 'br1=uicontrol(''style'',''push'',''units'',''normal'',''pos'','];
minorgen=[minorgen 'pl,''string'',''R1'','];
minorgen=[minorgen '''fontweight'',''bold'',''fontsize'',10,'];
minorgen=[minorgen '''call'',''cnum=1;eval(wiper);dispmin'');'];

minorgen=[minorgen 'ii=2;pl=[xstart+(4)*.06 ystart+(4-ii)*.06 .03 .03];'];
minorgen=[minorgen 'br2=uicontrol(''style'',''push'',''units'',''normal'',''pos'','];
minorgen=[minorgen 'pl,''string'',''R2'','];
minorgen=[minorgen '''fontweight'',''bold'',''fontsize'',10,'];
minorgen=[minorgen '''call'',''cnum=2;eval(wiper);dispmin'');'];

minorgen=[minorgen 'ii=3;pl=[xstart+(4)*.06 ystart+(4-ii)*.06 .03 .03];'];
minorgen=[minorgen 'br3=uicontrol(''style'',''push'',''units'',''normal'',''pos'','];
minorgen=[minorgen 'pl,''string'',''R3'','];
minorgen=[minorgen '''fontweight'',''bold'',''fontsize'',10,'];
minorgen=[minorgen '''call'',''cnum=3;eval(wiper);dispmin'');'];

minorgen=[minorgen 'ii=4;pl=[xstart+(4)*.06 ystart+(4-ii)*.06 .03 .03];'];
minorgen=[minorgen 'br4=uicontrol(''style'',''push'',''units'',''normal'',''pos'','];
minorgen=[minorgen 'pl,''string'',''R4'','];
minorgen=[minorgen '''fontweight'',''bold'',''fontsize'',10,'];
minorgen=[minorgen '''call'',''cnum=4;eval(wiper);dispmin'');'];

minorgen=[minorgen 'end;'];








%GRAPHICS
%
hfig=figure('units','normal','position',[0 0 1 1]);
axis('off')
origfig=gcf;  %number of original figure generated by this routine

%SUBPLOTS
axhead=subplot('position',[.35 .95 .3 .1]);axis('off')    %header
axAname=subplot('position',[.02 .83 .05 .05]);axis('off');%matrix name A
axmin=subplot('position',[.45 .55 .55 .35]);axis('off');  %display of minors
axdet=subplot('position',[.02 .35 .8 .15]);axis('off');   %display of det
axvan=subplot('position',[.02 .01 .1 .05]);axis('off');   %vanity

%TITLE
%
subplot(axhead);
text(0,0,header,'color','m',...
     'erasemode','none','fontweight','bold','fontsize',22)
drawnow

subplot(axvan);
text(0,0,'by D.R.Hill','color','black','fontsize',10,...
     'fontweight','bold','fontangle','oblique','erasemode','none');

%pause

subplot(axAname);
text(0,0,'A = ','color','k',...
     'erasemode','none','fontweight','bold','fontsize',24)


xstart=.1;ystart=.7;

for ii=4:-1:1    %each of the entries of A is given a button name
   for jj=1:4    %according to its row-col position
       st=['r' num2str(ii) 'c' num2str(jj)];
       place='[xstart+(jj-1)*.06 ystart+(4-ii)*.06 .045 .045]';
       part1=['uicontrol(''style'',''push'',''units'',''normal'',''pos'','];
       part2=['''string'','];
       part3=[',''fontweight'',''bold'',''fontsize'',16,''call'',dummy);'];
       st=[st '=' part1 'eval(place),' part2 mat2str(A(ii,jj)) part3];
       eval(st);
       drawnow
    end
end

%
%MESSAGE area    Borrowed from a MathWorks Routine
    %===================================

    % Set up the Comment Window
    top=0.2;
    left=0.05;
    right=0.5;
    bottom=0.05;
    labelHt=0.05;
    spacing=0.005;
    promptStr= ' ';

    % First, the Comment Window frame
    frmBorder=0.02;
    frmPos=[left-frmBorder bottom-frmBorder ...
	(right-left)+2*frmBorder (top-bottom)+2*frmBorder];
    uicontrol( ...
        'Style','frame', ...
        'Units','normalized', ...
        'Position',frmPos, ...
	'BackgroundColor',[0.50 0.50 0.50]);
    % Then the text label
    labelPos=[left top-labelHt (right-left) labelHt];
    uicontrol( ...
	'Style','text', ...
        'Units','normalized', ...
        'Position',labelPos, ...
        'BackgroundColor',[0.50 0.50 0.50], ...
	'ForegroundColor','black', ...
        'String','Comment Window');
    % Then the text field(s)
    
    txtPos=[left top-labelHt-2*frmBorder (right-left) labelHt];
    txtPos1=[left top-2*labelHt-2*frmBorder (right-left) labelHt];
    txtHndl=uicontrol( ...
	'Style','text', ...
        'Units','normalized', ...
        'BackgroundColor',[1 1 1], ...
        'Position',txtPos, ...
        'String',promptStr,'foregroundcolor','red');
    txtHndl1=uicontrol( ...
	'Style','text', ...
        'Units','normalized', ...
        'BackgroundColor',[1 1 1], ...
        'Position',txtPos1, ...
        'String',promptStr,'foregroundcolor','red');
%First Message

set(txtHndl,'string','Select Expansion Mode;',...
   'fontweight','bold','fontsize',14);
set(txtHndl1,'string','ROW or COLUMN.',...
    'fontweight','bold','fontsize',14);

%BUTTONS for ROW/COLUMN
%
rcbutfrm=uicontrol('style','frame','units','normal',...
                 'position',[.54 .04 .13 .11],'backgroundcolor','y');
rowbut = uicontrol('style','push','units','normal','pos',[.55 .1 .11 .04], ...
        'string','ROW','fontweight','bold','fontsize',12,...
        'call',rowsel);
colbut = uicontrol('style','push','units','normal','pos',[.55 .05 .11 .04], ...
        'string','COLUMN','fontweight','bold','fontsize',12,...
        'call',colsel);

%buttons for help/quit/etc

hbutfrm=uicontrol('style','frame','units','normal',...
                 'position',[.84 .04 .14 .17],'backgroundcolor','y');

helpbut = uicontrol('style','push','units','normal','pos',[.85 .15 .12 .04], ...
        'string','HELP','fontweight','bold','fontsize',12,...
        'call',helps);

restbut = uicontrol('style','push','units','normal','pos',[.85 .1 .12 .04], ...
        'string','RESTART','fontweight','bold','fontsize',12,...
        'call','close(gcf),detrecur');

quitbut = uicontrol('style','push','units','normal','pos',[.85 .05 .12 .04], ...
        'string','QUIT','fontweight','bold','fontsize',12,...
        'call',done);


return

