%DISPMIN  Display a minor. Used as part of detrecur.  9/15/98
%         Here we compute the minors and display them as
%         column or row buttons are pushed.
%
%         Uses routines mat2strh, outline and detminor.
%
%         After all minors are displayed this routine shows
%         det(A) as a linear combination of dets of minors.
%         it then calls detminor.
%
%  By: David R. Hill, Mathematics Dept., Temple Univ.
%      Philadelphia, PA. 19122    Email: dhill001@temple.edu

accesscnt=accesscnt+1;

subplot(axmin);

if expmode=='R'
   expmode1='C';clr='y';
else
   expmode1='R';clr='c';
end

loc=cnum;
outline

rvals=1:matsize;cvals=rvals;
if expmode=='R'
   rk=expnum;ck=cnum;
else
   rk=cnum;ck=expnum;
end
rvals(rk)=200;cvals(ck)=200;
rvals=sort(rvals);cvals=sort(cvals);
rvals=rvals(1:matsize-1);cvals=cvals(1:matsize-1);
minmat=A(rvals,cvals);
mat=mat2strh(minmat,2);

matname=['M(' num2str(rk) ',' num2str(ck) ') = '];
if cnum==1
   text(0,.75,matname,'erasemode','none','fontweight','bold','fontsize',12);
   text(.2,.9,mat(1,:),'erasemode','none','fontweight','bold','fontsize',12);
   text(.2,.75,mat(2,:),'erasemode','none','fontweight','bold','fontsize',12);
   text(.2,.6,mat(3,:),'erasemode','none','fontweight','bold','fontsize',12);
end

if cnum==2
   text(.5,.75,matname,'erasemode','none','fontweight','bold','fontsize',12);
   text(.7,.9,mat(1,:),'erasemode','none','fontweight','bold','fontsize',12);
   text(.7,.75,mat(2,:),'erasemode','none','fontweight','bold','fontsize',12);
   text(.7,.6,mat(3,:),'erasemode','none','fontweight','bold','fontsize',12);
end

if cnum==3
   text(0,.25,matname,'erasemode','none','fontweight','bold','fontsize',12);
   text(.2,.4,mat(1,:),'erasemode','none','fontweight','bold','fontsize',12);
   text(.2,.25,mat(2,:),'erasemode','none','fontweight','bold','fontsize',12);
   text(.2,.1,mat(3,:),'erasemode','none','fontweight','bold','fontsize',12);
end

if cnum==4
   text(.5,.25,matname,'erasemode','none','fontweight','bold','fontsize',12);
   text(.7,.4,mat(1,:),'erasemode','none','fontweight','bold','fontsize',12);
   text(.7,.25,mat(2,:),'erasemode','none','fontweight','bold','fontsize',12);
   text(.7,.1,mat(3,:),'erasemode','none','fontweight','bold','fontsize',12);
end

%pause(3)

mline1=['Minor(' num2str(rk) ',' num2str(ck) ') is shown.'];
mline2=['Press ENTER to go on.'];
set(txtHndl,'string',mline1,...
   'fontweight','bold','fontsize',14);
set(txtHndl1,'string',mline2,...
    'fontweight','bold','fontsize',14);
pause

%expmode1=expmode;clr='r';loc=expnum;
%outline

if expmode=='R' %& rk==1 
   if ck==1,delete(br1c1),delete(br2c1);delete(br3c1);delete(br4c1);end
   if ck==2,delete(br1c2),delete(br2c2);delete(br3c2);delete(br4c2);end
   if ck==3,delete(br1c3),delete(br2c3);delete(br3c3);delete(br4c3);end
   if ck==4,delete(br1c4),delete(br2c4);delete(br3c4);delete(br4c4);end
end

%if expmode=='R' & rk==2 
%   if ck==1,delete(br1c1);delete(br3c1);delete(br4c1);end
%   if ck==2,delete(br1c2);delete(br3c2);delete(br4c2);end
%   if ck==3,delete(br1c3);delete(br3c3);delete(br4c3);end
%   if ck==4,delete(br1c4);delete(br3c4);delete(br4c4);end
%end

%if expmode=='R' & rk==3 
%   if ck==1,delete(br1c1);delete(br2c1);delete(br4c1);end
%   if ck==2,delete(br1c2);delete(br2c2);delete(br4c2);end
%   if ck==3,delete(br1c3);delete(br2c3);delete(br4c3);end
%   if ck==4,delete(br1c4);delete(br2c4);delete(br4c4);end
%end

%if expmode=='R' & rk==4 
%   if ck==1,delete(br1c1);delete(br2c1);delete(br3c1);end
%   if ck==2,delete(br1c2);delete(br2c2);delete(br3c2);end
%   if ck==3,delete(br1c3);delete(br2c3);delete(br3c3);end
%   if ck==4,delete(br1c4);delete(br2c4);delete(br3c4);end
%end

if expmode=='C' %& ck==1 
   if rk==1,delete(br1c1);delete(br1c2);delete(br1c3);delete(br1c4);end
   if rk==2,delete(br2c1);delete(br2c2);delete(br2c3);delete(br2c4);end
   if rk==3,delete(br3c1);delete(br3c2);delete(br3c3);delete(br3c4);end
   if rk==4,delete(br4c1);delete(br4c2);delete(br4c3);delete(br4c4);end
end

%if expmode=='C' & ck==2 
%   if rk==1,delete(br1c1);delete(br1c3);delete(br1c4);end
%   if rk==2,delete(br2c1);delete(br2c3);delete(br2c4);end
%   if rk==3,delete(br3c1);delete(br3c3);delete(br3c4);end
%   if rk==4,delete(br4c1);delete(br4c3);delete(br4c4);end
%end

%if expmode=='C' & ck==3 
%   if rk==1,delete(br1c1);delete(br1c2);delete(br1c4);end
%   if rk==2,delete(br2c1);delete(br2c2);delete(br2c4);end
%   if rk==3,delete(br3c1);delete(br3c2);delete(br3c4);end
%   if rk==4,delete(br4c1);delete(br4c2);delete(br4c4);end
%end

%if expmode=='C' & ck==4 
%   if rk==1,delete(br1c1);delete(br1c2);delete(br1c3);end
%   if rk==2,delete(br2c1);delete(br2c2);delete(br2c3);end
%   if rk==3,delete(br3c1);delete(br3c2);delete(br3c3);end
%   if rk==4,delete(br4c1);delete(br4c2);delete(br4c3);end
%end

if accesscnt<4
   set(txtHndl,'string','Make next Selection.',...
   'fontweight','bold','fontsize',14);
   set(txtHndl1,'string',' ',...
    'fontweight','bold','fontsize',14);
else
   for kk=1:4
      if expandbut(kk,3)=='1' & expandbut(kk,5)=='1',delete(br1c1r);end
      if expandbut(kk,3)=='1' & expandbut(kk,5)=='2',delete(br1c2r);end
      if expandbut(kk,3)=='1' & expandbut(kk,5)=='3',delete(br1c3r);end
      if expandbut(kk,3)=='1' & expandbut(kk,5)=='4',delete(br1c4r);end
      if expandbut(kk,3)=='2' & expandbut(kk,5)=='1',delete(br2c1r);end
      if expandbut(kk,3)=='2' & expandbut(kk,5)=='2',delete(br2c2r);end
      if expandbut(kk,3)=='2' & expandbut(kk,5)=='3',delete(br2c3r);end
      if expandbut(kk,3)=='2' & expandbut(kk,5)=='4',delete(br2c4r);end
      if expandbut(kk,3)=='3' & expandbut(kk,5)=='1',delete(br3c1r);end
      if expandbut(kk,3)=='3' & expandbut(kk,5)=='2',delete(br3c2r);end
      if expandbut(kk,3)=='3' & expandbut(kk,5)=='3',delete(br3c3r);end
      if expandbut(kk,3)=='3' & expandbut(kk,5)=='4',delete(br3c4r);end
      if expandbut(kk,3)=='4' & expandbut(kk,5)=='1',delete(br4c1r);end
      if expandbut(kk,3)=='4' & expandbut(kk,5)=='2',delete(br4c2r);end
      if expandbut(kk,3)=='4' & expandbut(kk,5)=='3',delete(br4c3r);end
      if expandbut(kk,3)=='4' & expandbut(kk,5)=='4',delete(br4c4r);end
   end   
   set(txtHndl,'string','Press ENTER to see det(A) expanded',...
   'fontweight','bold','fontsize',12);
   mline2=['about '];
   if expmode == 'R'
      mline2=['about row ' num2str(expnum) ' in recursive form.'];
   else
      mline2=['about column ' num2str(expnum) ' in recursive form.'];
   end
   set(txtHndl1,'string',mline2,...
    'fontweight','bold','fontsize',12);
   pause
end

if accesscnt==4
   set(txtHndl,'string','det(A) as a linear combination',...
   'fontweight','bold','fontsize',14);
   set(txtHndl1,'string','of determinants of 3 by 3 matrices.',...
    'fontweight','bold','fontsize',14);
   subplot(axdet);
   detdisp='det(A) = ';
   sign1=(-1)^(expnum+1);
   if sign1 > 0
      sgn=[' + ';' - ';' + ';' - '];
   else
      sgn=[' - ';' + ';' - ';' + '];
   end
   if sign1<0,detdisp=[detdisp sgn(1,:)];end
   if expmode=='R'
      detdisp=[detdisp '(' num2str(A(expnum,1)) ')*det(M(' num2str(expnum) ',' num2str(1) '))'];
      detdisp=[detdisp sgn(2,:) '(' num2str(A(expnum,2)) ')*det(M(' num2str(expnum) ',' num2str(2) '))'];
      detdisp=[detdisp sgn(3,:) '(' num2str(A(expnum,3)) ')*det(M(' num2str(expnum) ',' num2str(3) '))'];
      detdisp=[detdisp sgn(4,:) '(' num2str(A(expnum,4)) ')*det(M(' num2str(expnum) ',' num2str(4) '))'];
   else
      detdisp=[detdisp '(' num2str(A(1,expnum)) ')*det(M(' num2str(1) ',' num2str(expnum) '))'];
      detdisp=[detdisp sgn(2,:) '(' num2str(A(2,expnum)) ')*det(M(' num2str(2) ',' num2str(expnum) '))'];
      detdisp=[detdisp sgn(3,:) '(' num2str(A(3,expnum)) ')*det(M(' num2str(3) ',' num2str(expnum) '))'];
      detdisp=[detdisp sgn(4,:) '(' num2str(A(4,expnum)) ')*det(M(' num2str(4) ',' num2str(expnum) '))'];
   end

   bigdisp=text(0,.5,detdisp,'color','r',...
       'fontweight','bold','fontsize',12);
   pause(5)
   mline1=['Press ENTER to go on and compute'];
   mline2=['the determinants of the minors.'];
   set(txtHndl,'string',mline1,...
       'fontweight','bold','fontsize',12);
   set(txtHndl1,'string',mline2,...
       'fontweight','bold','fontsize',12);
   pause
   detminor
end

return

