%dmincalc  Calculating the determinant of a minor as part of detrecur.  3/29/00
%          Called by detminor to set up a second graphics screen for 
%          calculation of dets of minors.
%
%          Uses routines:  mat2strh
%          Calls routine dethaveit to process the value the det of a minor.
%          Calls routine drecurm to show the recursive aid for computation
%                of the det of a 3 by 3 minor.
%
%  By: David R. Hill, Mathematics Dept., Temple Univ.
%      Philadelphia, PA. 19122    Email: dhill001@temple.edu

%STRINGS
headminor=['Computing ' name];

%The input matrix is called B
Bstr=mat2strh(B,2);  %converting the minor matrix for display
Bstrcol12=mat2strh(B(:,1:2),2); %first 2 cols for 3 by 3 trick
detB=det(B);         %value of det for use later in checking

%callbacks
seefirst='figure(origfig);'; %insert a button on original screen to return to this screen
seefirst=[seefirst 'retbut = uicontrol(''style'',''push'',''units'',''normal'','];
seefirst=[seefirst '''pos'',[.85 .25 .12 .04],''string'',''Go BACK'','];
seefirst=[seefirst '''fontweight'',''bold'',''fontsize'',12,''call'',''figure(origfig+1);'];
seefirst=[seefirst 'delete(retbut);'');'];

handcalc='mess1=''Compute the det value. Then click in the'';';
handcalc=[handcalc 'mess2=''entry box to type your answer.'';'];
handcalc=[handcalc 'set(txtHndlm,''string'',mess1,''fontweight'',''bold'',''fontsize'',12);'];
handcalc=[handcalc 'set(txtHndlm1,''string'',mess2,''fontweight'',''bold'',''fontsize'',12);'];
handcalc=[handcalc 'eval(wipecomp);eval(entrybox);'];

trick33='subplot(ax33trick);';
trick33=[trick33 'text(0,.9,Bstr(1,:),''erasemode'',''none'','];
trick33=[trick33 '''fontweight'',''bold'',''fontsize'',16);'];
trick33=[trick33 'text(0,.5,Bstr(2,:),''erasemode'',''none'','];
trick33=[trick33 '''fontweight'',''bold'',''fontsize'',16);'];
trick33=[trick33 'text(0,.1,Bstr(3,:),''erasemode'',''none'','];
trick33=[trick33 '''fontweight'',''bold'',''fontsize'',16);'];
trick33=[trick33 'text(.5,.9,Bstrcol12(1,:),''erasemode'',''none'','];
trick33=[trick33 '''fontweight'',''bold'',''fontsize'',16,''color'',''r'');'];
trick33=[trick33 'text(.5,.5,Bstrcol12(2,:),''erasemode'',''none'','];
trick33=[trick33 '''fontweight'',''bold'',''fontsize'',16,''color'',''r'');'];
trick33=[trick33 'text(.5,.1,Bstrcol12(3,:),''erasemode'',''none'','];
trick33=[trick33 '''fontweight'',''bold'',''fontsize'',16,''color'',''r'');'];
trick33=[trick33 'subplot(ax33mess);'];
trick33=[trick33 'text(0,.9,''Use the 3 by 3 device'',''erasemode'',''none'','];
trick33=[trick33 '''fontweight'',''bold'',''fontsize'',16,''color'',''b'');'];
trick33=[trick33 'text(0,0,''on this display.'',''erasemode'',''none'','];
trick33=[trick33 '''fontweight'',''bold'',''fontsize'',16,''color'',''b'');'];

recuraid=['mrcbutfrm=uicontrol(''style'',''frame'',''units'','];
recuraid=[recuraid '''normal'',''position'',[.54 .02 .13 .11],'];
recuraid=[recuraid '''backgroundcolor'',''y'');'];
recuraid=[recuraid 'rowbutm = uicontrol(''style'',''push'',''units'',''normal'','];
recuraid=[recuraid '''pos'',[.55 .08 .11 .04],''string'',''ROW'','];
recuraid=[recuraid '''fontweight'',''bold'',''fontsize'',12,''call'',rowselm);'];
recuraid=[recuraid 'colbutm = uicontrol(''style'',''push'','];
recuraid=[recuraid '''units'',''normal'',''pos'',[.55 .03 .11 .04],'];
recuraid=[recuraid '''string'',''COLUMN'',''fontweight'',''bold'','];
recuraid=[recuraid '''fontsize'',12,''call'',colselm);'];




%routines evaled
wipecomp='delete(handbut);delete(trick3but);delete(recurbut);delete(cbutfrm);';

entrybox='subplot(axentry);curmin=text(0,.5,[name '' = ''],''color'',''k'',';
entrybox=[entrybox '''erasemode'',''none'',''fontweight'',''bold'',''fontsize'',16);'];
entrybox=[entrybox 'detval=uicontrol(''Style'',''edit'',''units'',''normal'','];
entrybox=[entrybox '''position'',[.6 .79 .1 .07],''back'',''y'',''fontsize'',14,'];
entrybox=[entrybox '''fontweight'',''bold'',''HorizontalAlignment'',''left'','];
entrybox=[entrybox '''call'', ''eval(havdet)'');'];
entrybox=[entrybox 'subplot(axentrylabel);'];
entrybox=[entrybox 'text(0,.9,''Click in the yellow box.'',''fontweight'',''bold'','];
entrybox=[entrybox '''fontsize'',12,''erasemode'',''none'',''color'',''b'');'];
entrybox=[entrybox 'text(0,.5,''Type the det value,'',''fontweight'',''bold'','];
entrybox=[entrybox '''fontsize'',12,''erasemode'',''none'',''color'',''b'');'];
entrybox=[entrybox 'text(0,0,''then press ENTER.'',''fontweight'',''bold'','];
entrybox=[entrybox '''fontsize'',12,''erasemode'',''none'',''color'',''b'');'];

            %show sign pattern for recursive aid
havdet='detvalB=str2num(get(detval,''string''));dethaveit';
            %check if correct;if so then insert in display from first page 
            %delete second figure
            %wipe out button just done on first page
            %keep track of # done; when all done give value
            %if not correct put up message to redo calculation
            
%used when selecting row or colmun in recuraid
rowselm='mexpmode=''R'';delete(rowbutm);delete(colbutm);delete(mrcbutfrm);eval(getnumberm);';
colselm='mexpmode=''C'';delete(rowbutm);delete(colbutm);delete(mrcbutfrm);eval(getnumberm);';

%what to do once we selected row or column mode for expansion
getnumberm=['mnumbutfrm=uicontrol(''style'',''frame'',''units'',''normal'','];
getnumberm=[getnumberm '''position'',[.54 .04 .12 .17],''backgroundcolor'',''y'');'];
getnumberm=[getnumberm 'if mexpmode==''R'',st=''Select Row Number'';else,st=''Select Column Number'';end,'];
getnumberm=[getnumberm 'set(txtHndlm,''string'',st,''fontweight'',''bold'',''fontsize'',14);'];
getnumberm=[getnumberm 'set(txtHndlm1,''string'',''to expand about.'','];
getnumberm=[getnumberm '''fontweight'',''bold'',''fontsize'',14);'];
getnumberm=[getnumberm 'mnum1but = uicontrol(''style'',''push'',''units'',''normal'','];
getnumberm=[getnumberm '''pos'',[.55 .15 .1 .04],''string'',''1'',''fontweight'',''bold'','];
getnumberm=[getnumberm '''fontsize'',12,''call'',''mexpnum=1;eval(mwipenums);'');'];
getnumberm=[getnumberm 'mnum2but = uicontrol(''style'',''push'',''units'',''normal'','];
getnumberm=[getnumberm '''pos'',[.55 .1 .1 .04],''string'',''2'',''fontweight'',''bold'','];
getnumberm=[getnumberm '''fontsize'',12,''call'',''mexpnum=2;eval(mwipenums);'');'];
getnumberm=[getnumberm 'mnum3but = uicontrol(''style'',''push'',''units'',''normal'','];
getnumberm=[getnumberm '''pos'',[.55 .05 .1 .04],''string'',''3'',''fontweight'',''bold'','];
getnumberm=[getnumberm '''fontsize'',12,''call'',''mexpnum=3;eval(mwipenums);'');'];
%WIPE OUT number buttons
%
mwipenums='delete(mnum1but);delete(mnum2but);delete(mnum3but);delete(mnumbutfrm);';
mwipenums=[mwipenums 'mexpmode1=mexpmode;mloc=mexpnum;'];
mwipenums=[mwipenums 'set(txtHndlm,''string'',''Generating the recursive form.'',''fontweight'',''bold'',''fontsize'',14);'];
mwipenums=[mwipenums 'stmess='' '';'];
mwipenums=[mwipenums 'set(txtHndlm1,''string'',stmess,'];
mwipenums=[mwipenums '''fontweight'',''bold'',''fontsize'',14);'];
mwipenums=[mwipenums 'eval(mminorgen);'];

mminorgen='drecurm';

%START GRAPHICS
hfig=figure('units','normal','position',[0 0 1 1]);
axis('off')

%SUBPLOTS
axheadmin=subplot('position',[.35 .95 .3 .1]);axis('off')    %header
axvanmin=subplot('position',[.02 .01 .1 .05]);axis('off');   %vanity
axMname=subplot('position',[.02 .83 .05 .05]);axis('off');%minor matrix name
axmat=subplot('position',[.2 .78 .1 .1]);axis('off');    %the minor matrix 
axentry=subplot('position',[.4 .78 .18 .1]);axis('off');  %entry box
axentrylabel=subplot('position',[.65 .68 .1 .09]);axis('off');  %entry box
ax33trick=subplot('position',[.01 .5 .3 .1]);axis('off');%3 by 3 trick matrix
ax33mess=subplot('position',[.01 .4 .3 .05]);axis('off');
axraid1=subplot('position',[.35 .5 .1 .15]);axis('off');
axraid2=subplot('position',[.55 .5 .15 .15]);axis('off');
axraid3=subplot('position',[.55 .35 .15 .15]);axis('off');
axraid4=subplot('position',[.55 .2 .15 .15]);axis('off');


subplot(axheadmin);
text(0,0,headminor,'color','m',...
     'erasemode','none','fontweight','bold','fontsize',22)
drawnow

subplot(axvanmin);
text(0,0,'by D.R.Hill','color','black','fontsize',10,...
     'fontweight','bold','fontangle','oblique','erasemode','none');

subplot(axMname);
text(0,0,[name ' = '],'color','k',...
     'erasemode','none','fontweight','bold','fontsize',16)

subplot(axmat);
text(0,.9,Bstr(1,:),'erasemode','none','fontweight','bold','fontsize',16);
text(0,.5,Bstr(2,:),'erasemode','none','fontweight','bold','fontsize',16);
text(0,.1,Bstr(3,:),'erasemode','none','fontweight','bold','fontsize',16);

%
%MESSAGE area    Borrowed from a MathWorks Routine
    %===================================

    % Set up the Comment Window
    top=0.2;
    left=0.05;
    right=0.5;
    bottom=0.05;
    labelHt=0.05;
    spacing=0.005;
    promptStr= ' ';

    % First, the Comment Window frame
    frmBorder=0.02;
    frmPos=[left-frmBorder bottom-frmBorder ...
	(right-left)+2*frmBorder (top-bottom)+2*frmBorder];
    uicontrol( ...
        'Style','frame', ...
        'Units','normalized', ...
        'Position',frmPos, ...
	'BackgroundColor',[0.50 0.50 0.50]);
    % Then the text label
    labelPos=[left top-labelHt (right-left) labelHt];
    uicontrol( ...
	'Style','text', ...
        'Units','normalized', ...
        'Position',labelPos, ...
        'BackgroundColor',[0.50 0.50 0.50], ...
	'ForegroundColor','black', ...
        'String','Comment Window');
    % Then the text field(s)
    
    txtPos=[left top-labelHt-2*frmBorder (right-left) labelHt];
    txtPos1=[left top-2*labelHt-2*frmBorder (right-left) labelHt];
    txtHndlm=uicontrol( ...
	'Style','text', ...
        'Units','normalized', ...
        'BackgroundColor',[1 1 1], ...
        'Position',txtPos, ...
        'String',promptStr,'foregroundcolor','red');
    txtHndlm1=uicontrol( ...
	'Style','text', ...
        'Units','normalized', ...
        'BackgroundColor',[1 1 1], ...
        'Position',txtPos1, ...
        'String',promptStr,'foregroundcolor','red');
%First Message

set(txtHndlm,'string','Click on a button.',...
   'fontweight','bold','fontsize',16);
set(txtHndlm1,'string',' ',...
    'fontweight','bold','fontsize',14);


%buttons for help/quit/etc
hbutfrmm=uicontrol('style','frame','units','normal',...
                 'position',[.84 .04 .14 .23],'backgroundcolor','y');

firstbutm = uicontrol('style','push','units','normal','pos',[.85 .2 .12 .04], ...
        'string','Go BACK','fontweight','bold','fontsize',12,...
        'call',seefirst);

helpbutm = uicontrol('style','push','units','normal','pos',[.85 .15 .12 .04], ...
        'string','HELP','fontweight','bold','fontsize',12,...
        'call',helps);

retbutm = uicontrol('style','push','units','normal','pos',[.85 .1 .12 .04], ...
        'string','RESTART','fontweight','bold','fontsize',12,...
        'call','close(gcf),detrecur');

quitbutm = uicontrol('style','push','units','normal','pos',[.85 .05 .12 .04], ...
        'string','QUIT','fontweight','bold','fontsize',12,...
        'call',done);



%buttons for computation
cbutfrm=uicontrol('style','frame','units','normal',...
                 'position',[.04 .24 .48 .11],'backgroundcolor','y');

handbut=uicontrol('style','push','units','normal','pos',[.05 .3 .15 .04], ...
        'string','Enter det.','fontweight','bold','fontsize',12,...
        'call',handcalc);

trick3but=uicontrol('style','push','units','normal','pos',[.21 .3 .3 .04], ...
        'string','Aid for 3 by 3 "device".','fontweight','bold','fontsize',12,...
        'call',trick33);

recurbut=uicontrol('style','push','units','normal','pos',[.05 .25 .3 .04], ...
        'string','Recursive expansion aid.','fontweight','bold','fontsize',12,...
        'call',recuraid);

        