%drecurm  Used as part of detrecur routine.            12/14/97
%         Displays recursive form of the determinant
%         of a 3 by 3 minor.
%
%         Called from dmincalc.
%  By: David R. Hill, Mathematics Dept., Temple Univ.
%      Philadelphia, PA. 19122    Email: dhill001@temple.edu
if mexpmode=='R'
   if mexpnum==1
      MM1=B([2 3],[2 3]);MM2=B([2 3],[1 3]);MM3=B([2 3],[1 2]);
   end
   if mexpnum==2
      MM1=B([1 3],[2 3]);MM2=B([1 3],[1 3]);MM3=B([1 3],[1 2]);
   end
   if mexpnum==3
      MM1=B([1 2],[2 3]);MM2=B([1 2],[1 3]);MM3=B([1 2],[1 2]);
   end
else
   if mexpnum==1
      MM1=B([2 3],[2 3]);MM2=B([1 3],[2 3]);MM3=B([1 2],[2 3]);
   end
   if mexpnum==2
      MM1=B([2 3],[1 3]);MM2=B([1 3],[1 3]);MM3=B([1 2],[1 3]);
   end
   if mexpnum==3
      MM1=B([2 3],[1 2]);MM2=B([1 3],[1 2]);MM3=B([1 2],[1 2]);
   end
end

sign1=(-1)^(mexpnum+1);
if sign1>0
   sgn=[' + ';' - ';' + ';' - '];
else
   sgn=[' - ';' + ';' - ';' + '];
end

mdetdisp1=[name ' = '];
if sign1<0,mdetdisp2b=[sgn(1,:)];else,mdetdisp2b=' ';end

   if mexpmode=='R'
      mdetdisp2b=[mdetdisp2b '(' num2str(B(mexpnum,1)) ')*det '];
      mdetdisp2a=mat2strh(MM1(1,:));mdetdisp2c=mat2strh(MM1(2,:));
      mdetdisp3b=[sgn(2,:) '(' num2str(B(mexpnum,2)) ')*det '];
      mdetdisp3a=mat2strh(MM2(1,:));mdetdisp3c=mat2strh(MM2(2,:));
      mdetdisp4b=[sgn(3,:) '(' num2str(B(mexpnum,3)) ')*det '];
      mdetdisp4a=mat2strh(MM3(1,:));mdetdisp4c=mat2strh(MM3(2,:));
   else
      mdetdisp2b=[mdetdisp2b '(' num2str(B(1,mexpnum)) ')*det '];
      mdetdisp2a=mat2strh(MM1(1,:));mdetdisp2c=mat2strh(MM1(2,:));
      mdetdisp3b=[sgn(2,:) '(' num2str(B(2,mexpnum)) ')*det '];
      mdetdisp3a=mat2strh(MM2(1,:));mdetdisp3c=mat2strh(MM2(2,:));
      mdetdisp4b=[sgn(3,:) '(' num2str(B(3,mexpnum)) ')*det '];
      mdetdisp4a=mat2strh(MM3(1,:));mdetdisp4c=mat2strh(MM3(2,:));
   end

%Now display things in their own subplots

subplot(axraid1);
text(0,.5,mdetdisp1,'color','k',...
     'erasemode','none','fontweight','bold','fontsize',14)
subplot(axraid2);
text(.8,.7,mdetdisp2a,'color','k',...
     'erasemode','none','fontweight','bold','fontsize',14)
text(0,.5,mdetdisp2b,'color','k',...
     'erasemode','none','fontweight','bold','fontsize',14)
text(.8,.3,mdetdisp2c,'color','k',...
     'erasemode','none','fontweight','bold','fontsize',14)
subplot(axraid3);
text(.8,.7,mdetdisp3a,'color','k',...
     'erasemode','none','fontweight','bold','fontsize',14)
text(0,.5,mdetdisp3b,'color','k',...
     'erasemode','none','fontweight','bold','fontsize',14)
text(.8,.3,mdetdisp3c,'color','k',...
     'erasemode','none','fontweight','bold','fontsize',14)
subplot(axraid4);
text(.8,.7,mdetdisp4a,'color','k',...
     'erasemode','none','fontweight','bold','fontsize',14)
text(0,.5,mdetdisp4b,'color','k',...
     'erasemode','none','fontweight','bold','fontsize',14)
text(.8,.3,mdetdisp4c,'color','k',...
     'erasemode','none','fontweight','bold','fontsize',14)