function gridutil(ax,xinc,yinc)  %6/16/98, 2/13/2005, 5/29/07, 6/20/2015
%GRIDUTIL   A utility to create a two dimensional plotting grid.
%           
%           
%           Use in the form  ==>  gridutil(ax,xinc,yinc)  <==
%
%               where    
%                      ax is a row with four entries
%                      ax = [xmin  xmax  ymin  ymax]
%
%                      xinc is the increment for tick marks on the x-axis
%
%                      yinc is the increment for tick marks on the x-axis
%  
%  The color and intensity of the grid lines can be changed; see last
%  command line. (gridalpha value is in [0, 1])
%
%  By: David R. Hill, Math Dept, Temple University,
%      Philadelphia, Pa. 19122   Email: dhill001@temple.edu

if nargin<3
   disp('ERROR in gridutil: not enough input arguments.')
   return
end  
%hfig=figure('units','normal','position',[0 0 1 1]);
hfig=figure('units','normal','position',[0 0 1 .9],'color','white');
axis('off')
grbox=subplot('position',[.1 .1 .8 .8]);
axis(ax);
set(grbox,'xtick',[ax(1):xinc:ax(2)],'ytick',[ax(3):yinc:ax(4)],...
    'xgrid','on','ygrid','on');
%set(grbox,'gridlinestyle','-') %sets the line style to solid
set(grbox,'gridlinestyle','-','gridColor','black','gridalpha',1)
%added 6/20/2015 from Technical Support Case #01405773 at the MathWorks

