%  << update 12/5/00;  6/26/2015
%GSPRAC3  Practice for the Gram-Schmidt process with 3-vectors.
%         Three linearly independent 3-vectors are transformed
%         into an orthogonal set and then normalized to form an
%         orthonormal set. The process is shown step-by-step graphically
%         and algebraically. The user must enter an appropriate coefficient
%         for the linear combination involved. You may enter a fraction or
%         a decimal accurate to four or more places.
%
%         Follow the directions that appear in the MESSAGE WINDOW.
%
%         A set of built-in vector pairs can be chosen or you can enter
%         your own three of 3-vectors.
%
%  Use in the form  ===>  gsprac3  <===
%                 
%  Uses utility mat2strh and gschmidt.
%
%  By: David R. Hill, Math Dept, Temple University,
%      Philadelphia, Pa. 19122   Email: dhill001@temple.edu

%strings
s0=' ';
s1='Your choice --> ';
s2='Displaying and graphing the vectors.';
s3='Starting the GRAM-Schmidt process.';
s4='Set new vector v1 = q1.';
s5='Construct v2 as a linear combination';
s6='of v1 and q2 so that it is orthogonal';
s7='to v1.';
s8='The number we seek here is';
s9=' v1''q2    Compute it. Click in the';
s10='-------     yellow box and type it.';
s11=' v1''v1   Then press ENTER. ';
s12='         (Use 4 or more dec. places.)';
s13='Number entered is valid.';
s14='Number entered is INCORRECT.';
s15='Click in the Message Window the press ENTER to try again.';
s16='The orthogonal pair v1 and v2';
s17='are shown graphically.';
s17a='Deleting vector q2 from the graph.';
s18='Next we make v1 and v2 unit vectors.';
s19='See the display and the graph.';
s20='Click on QUIT or RESTART.';
s21='The ORTHONORMAL pair, u1 and u2.';

s22='The first number we seek here is';
s23=' v1''q3    Compute it. Click in the';
s24='-------     yellow box and type it.';
s25=' v1''v1   Then press ENTER. ';
s26='         (Use 4 or more dec. places.)';

s27='The second number we seek here is';
s28=' v2''q3    Compute it. Click in the';
s29='-------     yellow box and type it.';
s30=' v2''v2   Then press ENTER. ';
s31='         (Use 4 or more dec. places.)';

s32='Construct v3 as a linear combination';
s33='of v1,v2, and q3 so that it is'; 
s34='orthogonal to both v1 and v2.';

s35='Vector v3 is shown on the graph';

s36='and its components are shown.';
s37='Deleting vector q3 from the graph.';
s38='Next we convert v1, v2, and v3 to';
s39='unit vectors.';
s40='The ORTHOGONAL Vectors.';
s41='The ORTHONORMAL Vectors.';
s42='Displaying the orthonormal vectors.';

cont1='Click in the Message Window then Press ENTER.';
cont='Press ENTER to continue.';
head=[blanks(30) 'GSPRAC3'];
head1=['BRIEF description/directions.'];
menu=['<1> Continue with Gram-Schmidt process.';
      '                                       ';
      '<0> Quit.                              '];

menu1=['<1> Enter three 3-vectors.                                ';
       '                                                          ';
       '<2> Choose a built-in demo of a set of 3-vectors.         ';
       '                                                          ';
       '<0> Quit.                                                 '];

demodata=['Choice #1       Choice #2     Choice #3      Choice #4 ';
          '                                                       ';
          '     1                5             1             -2   ';
          'q1 = 1           q1 = 0        q1 = 2         q1 = 0   ';
          '     1                3            -4              1   ';
          '                                                       ';
          '     1               -2             1              1   ';
          'q2 = 0           q2 = 1        q2 =-1         q2 = 5   ';
          '     1                1             1              2   ';
          '                                                       ';
          '     1               -1             4              1   ';
          'q3 =-2           q3 = 1        q3 =-3         q3 = 0   ';
          '     3                1             1              2   '];

clrs=['brc']; %colors  blue red cyan

n=2; %size of the n-vectors

%things that are evaled
%
%plotting the original vectors
pltorig='subplot(gr1sub),axis(ax),axis(axis),axis(''square''),hold on,';
pltorig=[pltorig 'q1v=plot3([0 q1(1)],[0 q1(2)],[0 q1(3)],[clrs(1) ''-''],'];
pltorig=[pltorig '''linewidth'',2);'];
pltorig=[pltorig 'q2v=plot3([0 q2(1)],[0 q2(2)],[0 q2(3)],[clrs(2) ''-''],'];
pltorig=[pltorig '''linewidth'',2);'];
pltorig=[pltorig 'q3v=plot3([0 q3(1)],[0 q3(2)],[0 q3(3)],[clrs(3) ''-''],'];
pltorig=[pltorig '''linewidth'',2);'];
pltorig=[pltorig 'grid on;'];
pltorig=[pltorig 'title(''The VECTORS'',''fontweight'',''bold'',''fontsize'',14);'];
pltorig=[pltorig 'subplot(messsub),ml1=text(.05,.9,s2,''color'',''k'','];
pltorig=[pltorig '''fontweight'',''bold'',''fontsize'',14);'];
pltorig=[pltorig 'ml2=text(.05,.1,cont1,''color'',''k'','];
pltorig=[pltorig '''fontweight'',''bold'',''fontsize'',14);'];
pltorig=[pltorig 'pause,delete(ml1),delete(ml2),'];

%showing the original vectors as a display
showvecs='subplot(vecsub),';
showvecs=[showvecs 'text(0,.9,''Original vectors: q1, q2, q3 .'','];
showvecs=[showvecs '''fontweight'',''bold'',''fontsize'',14);'];
showvecs=[showvecs 'q1m=text(0,.5,''q1 = '',''fontweight'',''bold'','];
showvecs=[showvecs '''color'',clrs(1),''fontsize'',14);'];
showvecs=[showvecs 'text(.1,.7,mat2strh(q1(1),2),''fontweight'',''bold'','];
showvecs=[showvecs '''color'',clrs(1),''fontsize'',14);'];
showvecs=[showvecs 'text(.1,.5,mat2strh(q1(2),2),''fontweight'',''bold'','];
showvecs=[showvecs '''color'',clrs(1),''fontsize'',14);'];
showvecs=[showvecs 'text(.1,.3,mat2strh(q1(3),2),''fontweight'',''bold'','];
showvecs=[showvecs '''color'',clrs(1),''fontsize'',14);'];
showvecs=[showvecs 'q2m=text(.4,.5,''q2 = '',''fontweight'',''bold'','];
showvecs=[showvecs '''color'',clrs(2),''fontsize'',14);'];
showvecs=[showvecs 'text(.5,.7,mat2strh(q2(1),2),''fontweight'',''bold'','];
showvecs=[showvecs '''color'',clrs(2),''fontsize'',14);'];
showvecs=[showvecs 'text(.5,.5,mat2strh(q2(2),2),''fontweight'',''bold'','];
showvecs=[showvecs '''color'',clrs(2),''fontsize'',14);'];
showvecs=[showvecs 'text(.5,.3,mat2strh(q2(3),2),''fontweight'',''bold'','];
showvecs=[showvecs '''color'',clrs(2),''fontsize'',14);'];
showvecs=[showvecs 'q3m=text(.75,.5,''q3 = '',''fontweight'',''bold'','];
showvecs=[showvecs '''color'',clrs(3),''fontsize'',14);'];
showvecs=[showvecs 'text(.85,.7,mat2strh(q3(1),2),''fontweight'',''bold'','];
showvecs=[showvecs '''color'',clrs(3),''fontsize'',14);'];
showvecs=[showvecs 'text(.85,.5,mat2strh(q3(2),2),''fontweight'',''bold'','];
showvecs=[showvecs '''color'',clrs(3),''fontsize'',14);'];
showvecs=[showvecs 'text(.85,.3,mat2strh(q3(3),2),''fontweight'',''bold'','];
showvecs=[showvecs '''color'',clrs(3),''fontsize'',14);'];

%setting up box to enter first coefficient
entrybox=[ 'subplot(infosub);c1box=uicontrol(''Style'',''edit'',''units'',''normal'','];
entrybox=[entrybox '''position'',[.13 .60 .15 .05],''back'',''y'',''fontsize'',14,'];
entrybox=[entrybox '''fontweight'',''bold'',''HorizontalAlignment'',''left'','];
entrybox=[entrybox '''call'', ''eval(havc1)'');'];

%getting entered value from entrybox & initiating check
havc1='c1val=str2num(get(c1box,''string''));eval(c1check)';

%setting up box to enter second coefficient
entrybox2=[ 'subplot(infosub);c2box=uicontrol(''Style'',''edit'',''units'',''normal'','];
entrybox2=[entrybox2 '''position'',[.13 .45 .15 .05],''back'',''y'',''fontsize'',14,'];
entrybox2=[entrybox2 '''fontweight'',''bold'',''HorizontalAlignment'',''left'','];
entrybox2=[entrybox2 '''call'', ''eval(havc2)'');'];

%getting entered value from entrybox & initiating check
havc2='c2val=str2num(get(c2box,''string''));eval(c2check)';

%setting up box to enter third coefficient
entrybox3=[ 'subplot(infosub);c3box=uicontrol(''Style'',''edit'',''units'',''normal'','];
entrybox3=[entrybox3 '''position'',[.33 .45 .15 .05],''back'',''y'',''fontsize'',14,'];
entrybox3=[entrybox3 '''fontweight'',''bold'',''HorizontalAlignment'',''left'','];
entrybox3=[entrybox3 '''call'', ''eval(havc3)'');'];

%getting entered value from entrybox & initiating check
havc3='c3val=str2num(get(c3box,''string''));eval(c3check)';

%checking if value entered in entrybox is valid
c1check='delete(ml1),delete(ml2),delete(ml3),delete(ml4),delete(ml5),';
c1check=[c1check 'if abs(c1val-c1true)<1.e-3,subplot(messsub),'];
c1check=[c1check 'ml1=text(.05,.9,s13,''color'',''k'',''fontweight'','];
c1check=[c1check '''bold'',''fontsize'',14);delete(c1box);subplot(infosub);'];
c1check=[c1check 'delete(v2disp),'];
c1check=[c1check 'c1coeff=text(0,.65,[''v2 = q2 - ('' num2str(c1val) '')*v1 = ''],'];
c1check=[c1check '''color'',''m'',''fontweight'',''bold'',''fontsize'',14);'];
c1check=[c1check 'text(.85,.72,num2str(v2(1)),''color'',''m'',''fontweight'','];
c1check=[c1check '''bold'',''fontsize'',14);'];
c1check=[c1check 'text(.85,.65,num2str(v2(2)),''color'',''m'',''fontweight'','];
c1check=[c1check '''bold'',''fontsize'',14);'];
c1check=[c1check 'text(.85,.58,num2str(v2(3)),''color'',''m'',''fontweight'','];
c1check=[c1check '''bold'',''fontsize'',14);'];
c1check=[c1check 'subplot(messsub),'];
c1check=[c1check 'ml2=text(.05,.1,cont1,''color'',''k'',''fontweight'','];
c1check=[c1check '''bold'',''fontsize'',14);'];
c1check=[c1check 'pause,delete(ml1),delete(ml2),eval(havorth2),'];
c1check=[c1check 'else,subplot(messsub),'];
c1check=[c1check 'ml1=text(.05,.9,s14,''color'',''k'',''fontweight'','];
c1check=[c1check '''bold'',''fontsize'',14);'];
c1check=[c1check 'ml2=text(.05,.5,s15,''color'',''k'',''fontweight'','];
c1check=[c1check '''bold'',''fontsize'',14);'];
c1check=[c1check 'pause,delete(c1box),delete(ml1),delete(ml2),'];
c1check=[c1check 'eval(showc1mess),eval(entrybox),end'];

%checking if value entered in entrybox2 is valid
c2check='delete(ml1),delete(ml2),delete(ml3),delete(ml4),delete(ml5),';
c2check=[c2check 'if abs(c2val-c2truea)<1.e-3,subplot(messsub),'];
c2check=[c2check 'ml1=text(.05,.9,s13,''color'',''k'',''fontweight'','];
c2check=[c2check '''bold'',''fontsize'',14);delete(c2box);subplot(infosub);'];
c2check=[c2check 'delete(v3disp),'];
c2check=[c2check 'v3disp=text(0,.4,[''v3 = q3 - ('' num2str(c2val) '')*v1 - (a number)*v2 ''],'];
c2check=[c2check '''color'',''k'',''fontweight'',''bold'',''fontsize'',14);'];
c2check=[c2check 'subplot(messsub),'];
c2check=[c2check 'ml2=text(.05,.1,cont1,''color'',''k'',''fontweight'','];
c2check=[c2check '''bold'',''fontsize'',14);'];
c2check=[c2check 'pause,delete(ml1),delete(ml2),eval(havpart1),'];
c2check=[c2check 'else,subplot(messsub),'];
c2check=[c2check 'ml1=text(.05,.9,s14,''color'',''k'',''fontweight'','];
c2check=[c2check '''bold'',''fontsize'',14);'];
c2check=[c2check 'ml2=text(.05,.5,s15,''color'',''k'',''fontweight'','];
c2check=[c2check '''bold'',''fontsize'',14);'];
c2check=[c2check 'pause,delete(c2box),delete(ml1),delete(ml2),'];
c2check=[c2check 'eval(showc2mess),eval(entrybox2),end'];

%checking if value entered in entrybox3 is valid
c3check='delete(ml1),delete(ml2),delete(ml3),delete(ml4),delete(ml5),';
c3check=[c3check 'if abs(c3val-c2trueb)<1.e-3,subplot(messsub),'];
c3check=[c3check 'ml1=text(.05,.9,s13,''color'',''k'',''fontweight'','];
c3check=[c3check '''bold'',''fontsize'',14);delete(c3box);subplot(infosub);'];

c3check=[c3check 'delete(v3disp),'];

c3check=[c3check 'c2coeff=text(0,.4,[''v3 = q3 - ('' num2str(c2val) '')*v1 - ('' num2str(c3val) '')*v2 ''],'];
c3check=[c3check '''color'',''k'',''fontweight'',''bold'',''fontsize'',14);'];
c3check=[c3check 'subplot(messsub),'];
c3check=[c3check 'ml2=text(.05,.1,cont1,''color'',''k'',''fontweight'','];
c3check=[c3check '''bold'',''fontsize'',14);'];
c3check=[c3check 'pause,delete(ml1),delete(ml2),eval(havpart2),'];
c3check=[c3check 'else,subplot(messsub),'];
c3check=[c3check 'ml1=text(.05,.9,s14,''color'',''k'',''fontweight'','];
c3check=[c3check '''bold'',''fontsize'',14);'];
c3check=[c3check 'ml2=text(.05,.5,s15,''color'',''k'',''fontweight'','];
c3check=[c3check '''bold'',''fontsize'',14);'];
c3check=[c3check 'pause,delete(c3box),delete(ml1),delete(ml2),'];
c3check=[c3check 'eval(showc3mess),eval(entrybox3),end'];


%showing the message on how to compute the first coefficient
showc1mess='subplot(messsub),ml1=text(.05,.9,s8,''color'',''k'',';
showc1mess=[showc1mess '''fontweight'',''bold'',''fontsize'',14);'];
showc1mess=[showc1mess 'ml2=text(.05,.7,s9,''color'',''k'','];
showc1mess=[showc1mess '''fontweight'',''bold'',''fontsize'',14);'];
showc1mess=[showc1mess 'ml3=text(.05,.5,s10,''color'',''k'','];
showc1mess=[showc1mess '''fontweight'',''bold'',''fontsize'',14);'];
showc1mess=[showc1mess 'ml4=text(.05,.3,s11,''color'',''k'','];
showc1mess=[showc1mess '''fontweight'',''bold'',''fontsize'',14);'];
showc1mess=[showc1mess 'ml5=text(.05,.1,s12,''color'',''k'','];
showc1mess=[showc1mess '''fontweight'',''bold'',''fontsize'',14);'];

%showing the message on how to compute the second coefficient
showc2mess='subplot(messsub),ml1=text(.05,.9,s22,''color'',''k'',';
showc2mess=[showc2mess '''fontweight'',''bold'',''fontsize'',14);'];
showc2mess=[showc2mess 'ml2=text(.05,.7,s23,''color'',''k'','];
showc2mess=[showc2mess '''fontweight'',''bold'',''fontsize'',14);'];
showc2mess=[showc2mess 'ml3=text(.05,.5,s24,''color'',''k'','];
showc2mess=[showc2mess '''fontweight'',''bold'',''fontsize'',14);'];
showc2mess=[showc2mess 'ml4=text(.05,.3,s25,''color'',''k'','];
showc2mess=[showc2mess '''fontweight'',''bold'',''fontsize'',14);'];
showc2mess=[showc2mess 'ml5=text(.05,.1,s26,''color'',''k'','];
showc2mess=[showc2mess '''fontweight'',''bold'',''fontsize'',14);'];

%showing the message on how to compute the third coefficient
showc3mess='subplot(messsub),ml1=text(.05,.9,s27,''color'',''k'',';
showc3mess=[showc3mess '''fontweight'',''bold'',''fontsize'',14);'];
showc3mess=[showc3mess 'ml2=text(.05,.7,s28,''color'',''k'','];
showc3mess=[showc3mess '''fontweight'',''bold'',''fontsize'',14);'];
showc3mess=[showc3mess 'ml3=text(.05,.5,s29,''color'',''k'','];
showc3mess=[showc3mess '''fontweight'',''bold'',''fontsize'',14);'];
showc3mess=[showc3mess 'ml4=text(.05,.3,s30,''color'',''k'','];
showc3mess=[showc3mess '''fontweight'',''bold'',''fontsize'',14);'];
showc3mess=[showc3mess 'ml5=text(.05,.1,s31,''color'',''k'','];
showc3mess=[showc3mess '''fontweight'',''bold'',''fontsize'',14);'];


%things after we have the orthogonal pair
havorth2='subplot(gr1sub),plot3([0 v2(1)],[0 v2(2)],[0 v2(3)],''m-'',';
havorth2=[havorth2 '''linewidth'',2);'];
havorth2=[havorth2 'v1n=text(v1(1),v1(2),v1(3),''v1'',''color'',''k'',''fontweight'','];
havorth2=[havorth2 '''bold'',''fontsize'',10);'];
havorth2=[havorth2 'v2n=text(v2(1),v2(2),v2(3),''v2'',''color'',''k'',''fontweight'','];
havorth2=[havorth2 '''bold'',''fontsize'',10);'];
havorth2=[havorth2 'subplot(messsub),'];
havorth2=[havorth2 'ml1=text(.05,.9,s16,''color'',''k'',''fontweight'','];
havorth2=[havorth2 '''bold'',''fontsize'',14);'];
havorth2=[havorth2 'ml2=text(.05,.7,s17,''color'',''k'',''fontweight'','];
havorth2=[havorth2 '''bold'',''fontsize'',14);'];
havorth2=[havorth2 'ml3=text(.05,.5,s17a,''color'',''r'',''fontweight'','];
havorth2=[havorth2 '''bold'',''fontsize'',14);'];
havorth2=[havorth2 'pause(3),delete(q2v),'];
havorth2=[havorth2 'ml4=text(.05,.1,cont1,''color'',''k'',''fontweight'','];
havorth2=[havorth2 '''bold'',''fontsize'',14);'];
havorth2=[havorth2 'pause,delete(ml1),delete(ml2),delete(ml3),delete(ml4),'];

%showing STEP#3
havorth2=[havorth2 'subplot(infosub),'];
havorth2=[havorth2 'text(0,.5,''Step #3'',''color'',''k'',''fontweight'','];
havorth2=[havorth2 '''bold'',''fontsize'',14);'];
havorth2=[havorth2 'subplot(messsub);'];
havorth2=[havorth2 'ml1=text(.05,.9,s32,''color'',''k'',''fontweight'','];
havorth2=[havorth2 '''bold'',''fontsize'',14);'];
havorth2=[havorth2 'ml2=text(.05,.7,s33,''color'',''k'',''fontweight'','];
havorth2=[havorth2 '''bold'',''fontsize'',14);'];
havorth2=[havorth2 'ml3=text(.05,.5,s34,''color'',''k'',''fontweight'','];
havorth2=[havorth2 '''bold'',''fontsize'',14);'];
havorth2=[havorth2 'subplot(infosub),'];
havorth2=[havorth2 'v3disp=text(0,.4,'];
havorth2=[havorth2 '''v3 = q3 - (a number)*v1 - (a number)*v2'','];
havorth2=[havorth2 '''color'',''k'',''fontweight'',''bold'',''fontsize'',14);'];
havorth2=[havorth2 'subplot(messsub);'];
havorth2=[havorth2 'ml4=text(.05,.1,cont1,''color'',''k'',''fontweight'','];
havorth2=[havorth2 '''bold'',''fontsize'',14);'];
havorth2=[havorth2 'pause,delete(ml1),delete(ml2),delete(ml3),delete(ml4),'];
havorth2=[havorth2 'eval(showc2mess),eval(entrybox2);'];

%+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
%have first coeff in v3; now get the second one
havpart1='eval(showc3mess),eval(entrybox3); ';

%+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
havpart2='ml1=text(.05,.9,s35,''color'',''k'',''fontweight'',';
havpart2=[havpart2 '''bold'',''fontsize'',14);'];
havpart2=[havpart2 'subplot(gr1sub),'];
havpart2=[havpart2 'plot3([0 v3(1)],[0 v3(2)],[0 v3(3)],''k-'','];
havpart2=[havpart2 '''linewidth'',2);'];
havpart2=[havpart2 'v3n=text(v3(1),v3(2),v3(3),''v3'',''color'',''k'',''fontweight'','];
havpart2=[havpart2 '''bold'',''fontsize'',10);'];
havpart2=[havpart2 'subplot(messsub),'];
havpart2=[havpart2 'ml2=text(.05,.7,s36,''color'',''k'',''fontweight'','];
havpart2=[havpart2 '''bold'',''fontsize'',14);'];
havpart2=[havpart2 'subplot(infosub),'];

%show components

havpart2=[havpart2 'v3dispa=text(0,.23,''v3 = '','];
havpart2=[havpart2 '''color'',''k'',''fontweight'',''bold'',''fontsize'',14);'];
havpart2=[havpart2 'text(.2,.3,num2str(v3(1)),''color'',''k'',''fontweight'','];
havpart2=[havpart2 '''bold'',''fontsize'',14);'];
havpart2=[havpart2 'text(.2,.23,num2str(v3(2)),''color'',''k'',''fontweight'','];
havpart2=[havpart2 '''bold'',''fontsize'',14);'];
havpart2=[havpart2 'text(.2,.16,num2str(v3(3)),''color'',''k'',''fontweight'','];
havpart2=[havpart2 '''bold'',''fontsize'',14);'];
havpart2=[havpart2 'subplot(messsub),'];
havpart2=[havpart2 'ml3=text(.05,.5,s37,''color'',''c'',''fontweight'','];
havpart2=[havpart2 '''bold'',''fontsize'',14);'];
havpart2=[havpart2 'pause(3),delete(q3v),'];
havpart2=[havpart2 'ml4=text(.05,.1,cont1,''color'',''k'',''fontweight'','];
havpart2=[havpart2 '''bold'',''fontsize'',14);pause,'];
havpart2=[havpart2 'delete(ml1),delete(ml2),delete(ml3),delete(ml4),'];
havpart2=[havpart2 'ml1=text(.05,.9,s38,''color'',''k'',''fontweight'','];
havpart2=[havpart2 '''bold'',''fontsize'',14);'];
havpart2=[havpart2 'ml2=text(.05,.7,s39,''color'',''k'',''fontweight'','];
havpart2=[havpart2 '''bold'',''fontsize'',14);'];
havpart2=[havpart2 'ml3=text(.05,.1,cont1,''color'',''k'',''fontweight'','];
havpart2=[havpart2 '''bold'',''fontsize'',14);pause,'];
havpart2=[havpart2 'delete(ml1),delete(ml2),delete(ml3),'];
havpart2=[havpart2 'delete(infosub),'];
havpart2=[havpart2 'infosub=subplot(''position'',[.01 .3 .38 .6]);axis(''off'');'];
havpart2=[havpart2 'text(0,.99,s40,''color'',''k'',''fontweight'','];
havpart2=[havpart2 '''bold'',''fontsize'',14);'];
havpart2=[havpart2 'text(0,.85,''v1 = '',''color'',''b'','];
havpart2=[havpart2 '''fontweight'',''bold'',''fontsize'',14);'];
havpart2=[havpart2 'text(.17,.92,mat2strh(q1(1)),''color'',''b'','];
havpart2=[havpart2 '''fontweight'',''bold'',''fontsize'',14);'];
havpart2=[havpart2 'text(.17,.85,mat2strh(q1(2)),''color'',''b'','];
havpart2=[havpart2 '''fontweight'',''bold'',''fontsize'',14);'];
havpart2=[havpart2 'text(.17,.78,mat2strh(q1(3)),''color'',''b'','];
havpart2=[havpart2 '''fontweight'',''bold'',''fontsize'',14);'];

havpart2=[havpart2 'text(.5,.85,''v2 = '',''color'',''m'','];
havpart2=[havpart2 '''fontweight'',''bold'',''fontsize'',14);'];
havpart2=[havpart2 'text(.67,.92,mat2strh(v2(1)),''color'',''m'','];
havpart2=[havpart2 '''fontweight'',''bold'',''fontsize'',14);'];
havpart2=[havpart2 'text(.67,.85,mat2strh(v2(2)),''color'',''m'','];
havpart2=[havpart2 '''fontweight'',''bold'',''fontsize'',14);'];
havpart2=[havpart2 'text(.67,.78,mat2strh(v2(3)),''color'',''m'','];
havpart2=[havpart2 '''fontweight'',''bold'',''fontsize'',14);'];

havpart2=[havpart2 'text(1,.85,''v3 = '',''color'',''k'','];
havpart2=[havpart2 '''fontweight'',''bold'',''fontsize'',14);'];
havpart2=[havpart2 'text(1.17,.92,mat2strh(v3(1)),''color'',''k'','];
havpart2=[havpart2 '''fontweight'',''bold'',''fontsize'',14);'];
havpart2=[havpart2 'text(1.17,.85,mat2strh(v3(2)),''color'',''k'','];
havpart2=[havpart2 '''fontweight'',''bold'',''fontsize'',14);'];
havpart2=[havpart2 'text(1.17,.78,mat2strh(v3(3)),''color'',''k'','];
havpart2=[havpart2 '''fontweight'',''bold'',''fontsize'',14);'];
%the unit vectors
havpart2=[havpart2 'text(0,.7,s41,''color'',''r'',''fontweight'','];
havpart2=[havpart2 '''bold'',''fontsize'',14);'];
havpart2=[havpart2 'text(0,.56,''u1 = '',''color'',''r'','];
havpart2=[havpart2 '''fontweight'',''bold'',''fontsize'',14);'];
havpart2=[havpart2 'text(.17,.63,mat2strh(u1(1)),''color'',''r'','];
havpart2=[havpart2 '''fontweight'',''bold'',''fontsize'',14);'];
havpart2=[havpart2 'text(.17,.56,mat2strh(u1(2)),''color'',''r'','];
havpart2=[havpart2 '''fontweight'',''bold'',''fontsize'',14);'];
havpart2=[havpart2 'text(.17,.49,mat2strh(u1(3)),''color'',''r'','];
havpart2=[havpart2 '''fontweight'',''bold'',''fontsize'',14);'];

havpart2=[havpart2 'text(.5,.56,''u2 = '',''color'',''r'','];
havpart2=[havpart2 '''fontweight'',''bold'',''fontsize'',14);'];
havpart2=[havpart2 'text(.67,.63,mat2strh(u2(1)),''color'',''r'','];
havpart2=[havpart2 '''fontweight'',''bold'',''fontsize'',14);'];
havpart2=[havpart2 'text(.67,.56,mat2strh(u2(2)),''color'',''r'','];
havpart2=[havpart2 '''fontweight'',''bold'',''fontsize'',14);'];
havpart2=[havpart2 'text(.67,.49,mat2strh(u2(3)),''color'',''r'','];
havpart2=[havpart2 '''fontweight'',''bold'',''fontsize'',14);'];

havpart2=[havpart2 'text(1,.56,''u3 = '',''color'',''r'','];
havpart2=[havpart2 '''fontweight'',''bold'',''fontsize'',14);'];
havpart2=[havpart2 'text(1.17,.63,mat2strh(u3(1)),''color'',''r'','];
havpart2=[havpart2 '''fontweight'',''bold'',''fontsize'',14);'];
havpart2=[havpart2 'text(1.17,.56,mat2strh(u3(2)),''color'',''r'','];
havpart2=[havpart2 '''fontweight'',''bold'',''fontsize'',14);'];
havpart2=[havpart2 'text(1.17,.49,mat2strh(u3(3)),''color'',''r'','];
havpart2=[havpart2 '''fontweight'',''bold'',''fontsize'',14);'];




%displaying the unit vectors
havpart2=[havpart2 'subplot(messsub),'];
havpart2=[havpart2 'ml1=text(.05,.9,s42,''color'',''k'',''fontweight'','];
havpart2=[havpart2 '''bold'',''fontsize'',14);pause(2);'];

%havpart2=[havpart2 %'subplot(gr1sub),delete(v1n),delete(v2n),delete(v3n),pause(2),'];
%changing axis to show unit vectors

havpart2=[havpart2 'delete(gr1sub),ax=[-1 1 -1 1 -1 1];']; %spot
havpart2=[havpart2 'gr1sub=subplot(''position'',[.5 .45 .45 .45]);'];
havpart2=[havpart2 'axis(ax),axis(axis),axis(''square''),hold on,'];
havpart2=[havpart2 'grid on,title(''Orthonormal Vectors'','];
havpart2=[havpart2 '''color'',''k'',''fontweight'','];
havpart2=[havpart2 '''bold'',''fontsize'',14);'];
havpart2=[havpart2 'plot3([0 u1(1)],[0 u1(2)],[0,u1(3)],''r-'','];
havpart2=[havpart2 '''linewidth'',2);'];
havpart2=[havpart2 'plot3([0 u2(1)],[0 u2(2)],[0 u2(3)],''r-'','];
havpart2=[havpart2 '''linewidth'',2);'];
havpart2=[havpart2 'plot3([0 u3(1)],[0 u3(2)],[0 u3(3)],''r-'','];
havpart2=[havpart2 '''linewidth'',2);'];
havpart2=[havpart2 'u1n=text(u1(1),u1(2),u1(3),''u1'',''color'',''k'',''fontweight'','];
havpart2=[havpart2 '''bold'',''fontsize'',10);'];
havpart2=[havpart2 'u2n=text(u2(1),u2(2),u2(3),''u2'',''color'',''k'',''fontweight'','];
havpart2=[havpart2 '''bold'',''fontsize'',10);'];
havpart2=[havpart2 'u3n=text(u3(1),u3(2),u3(3),''u3'',''color'',''k'',''fontweight'','];
havpart2=[havpart2 '''bold'',''fontsize'',10);'];
havpart2=[havpart2 'pause(1),subplot(messsub),'];
havpart2=[havpart2 'ml3=text(.05,.1,s20,''color'',''k'',''fontweight'','];
havpart2=[havpart2 '''bold'',''fontsize'',14);pause,'];

havpart2=[havpart2 'return;'];
%callbacks  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
%for quit button
done='close(gcf),clc,disp(''GSPRAC3 is over!''),return';

%++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++   

%data input
typeok='N';
while typeok=='N';
   clc,disp(head),disp(s0),disp(head1),disp(s0)
   disp(menu1)
   disp(s0)
   ch=input(s1);
   if isempty(ch),ch=99;,end
   if ch==2
      clc,disp(head),disp(s0)
      disp('Demo choices are:'),disp(demodata),disp(s0)
      democh=input(s1);
      if isempty(democh),democh=99;,end
      if democh~=1 & democh~=2 & democh~=3 & democh~=4
         disp(s0)
         disp('Improper choice. Press ENTER to begin again.')
         pause
      else
         typeok='Y';
      end
      if democh==1,q1=[1 1 1]';q2=[1 0 1]';q3=[1 -2 3]';A=[q1 q2 q3];end
      if democh==2,q1=[5 0 3]';q2=[-2 1 1]';q3=[-1 1 1]';A=[q1 q2 q3];end
      if democh==3,q1=[1 2 -4]';q2=[1 -1 1]';q3=[4 -3 1]';A=[q1 q2 q3];end
      if democh==4,q1=[-2 0 1]';q2=[1 5 2]';q3=[1 0 2]';A=[q1 q2 q3];end    
   end
   if ch==0,clc,disp('GSPRAC3 is over!'),return,end
   if ch==1
      dataok='N';
      while dataok=='N'
         clc,disp(head),disp(s0)
         disp('Enter a 3-vector in the form [1 2 3]')
         disp(s0)
         q1=input('vector q1 = ');q1=q1(:);  %making vector a column
         disp(s0)
         disp('Enter another 3-vector in the form [3 4 5]')
         disp(s0)
         q2=input('vector q2 = ');q2=q2(:);  %making vector a column
         disp(s0)
         disp('Enter a third 3-vector in the form [6 7 8]')
         disp(s0)
         q3=input('vector q3 = ');q3=q3(:);  %making vector a column
         disp(s0)
         A=[q1(:) q2(:) q3(:)];
         [nA mA]=size(A);
         matsum=sum(sum(A));
         imck=sum(sum(imag(A)));
         if nA~=3 | mA~=3 | imck~=0 | matsum==0 | abs(det(A))<100*eps
            disp('Vectors q1, q2, and q3 must be 3-vectors with real entries.')
            if matsum==0
               disp('Some entries must be nonzero.')
            end           
            if abs(det(A))<100*eps
               disp('Your vectors are not linearly independent.')
            end
            disp(s0),disp(cont),pause
         else      
            dataok='Y';typeok='Y';
         end
       end
   end
end


choiceok='N';
while choiceok=='N'
   format compact
   clc,disp(head)
   disp('Your vectors are displayed as the following columns.')
   disp(s0),disp(A)
   disp(s0)
   disp(menu),disp(s0)
   choice=input(s1);
   if isempty(choice),choice=99;,end
   if choice==0,clc,disp('GSPRAC3 is over!'),return,end
   if choice~=1
      disp(s0),disp('<><><>Improper choice; try again.')
      disp(cont)
      pause
   else
      choiceok='Y';format
   end
end

%setting numeric quantities
v1 = q1;
c1true=(v1'*q2)/(v1'*v1);
v2=q2-c1true*v1;
c2truea=(v1'*q3)/(v1'*v1);
c2trueb=(v2'*q3)/(v2'*v2);
v3=q3-c2truea*v1-c2trueb*v2;
u1=v1/norm(v1);
u2=v2/norm(v2);
u3=v3/norm(v3);
for jj=1:3  %try to prevent exponential form in displays
    if abs(v1(jj))<1.e-10,v1(jj)=0;end
    if abs(v2(jj))<1.e-10,v2(jj)=0;end
    if abs(v3(jj))<1.e-10,v3(jj)=0;end
    if abs(u1(jj))<1.e-10,u1(jj)=0;end
    if abs(u2(jj))<1.e-10,u2(jj)=0;end
    if abs(u3(jj))<1.e-10,u3(jj)=0;end
end






xl=min([q1(1) q2(1) q3(1) v2(1) v3(1)]);
xr=max([q1(1) q2(1) q3(1) v2(1) v3(1)]);
yb=min([q1(2) q2(2) q3(2) v2(2) v3(2)]);
yt=max([q1(2) q2(2) q3(2) v2(2) v3(2)]);
zb=min([q1(3) q2(3) q3(3) v2(3) v3(3)]);
zt=max([q1(3) q2(3) q3(3) v2(3) v3(3)]);

xsp=max([abs(xl) abs(xr)]);
ysp=max([abs(yb) abs(yt)]);
zsp=max([abs(zb) abs(zt)]);

axval=max([xsp ysp zsp]);
ax=axval*[-1 1 -1 1 -1 1];      %axis setup

%DOING THE GRAPHICS 
%setting graphics window to full size
hfig=figure('units','normal','position',[0 0 1 1]);
axis('off')

%the subplots
titlesub=subplot('position',[.01 .95 .4 .08]);axis('off');
gr1sub=subplot('position',[.5 .45 .45 .45]);%axis('off');
vanitysub=subplot('position',[.6 .1 .15 .05]);axis('off');
messsub=subplot('position',[.02 .1 .36 .15]);axis('off');
infosub=subplot('position',[.01 .3 .38 .6]);axis('off');
vecsub=subplot('position',[.4 .2 .55 .2]);axis('off');


%doing title
subplot(titlesub)
text(0,0,'GRAM-SCHMIDT Demo','color','r','fontweight','bold',...
         'fontsize',20);


%doing vanity
subplot(vanitysub);
text(0,0,'by D.R.Hill','color','black','fontsize',14,'fontweight','bold',...
     'fontangle','oblique')  

%doing message window
subplot(messsub);
plot([0 0 1 1 0],[0 1 1 0 0],'-k','linewidth',2);
axis('off')
title('Message Window','color','blue','fontsize',14);

%buttons for help/quit/etc
hbutfrm=uicontrol('style','frame','units','normal',...
                 'position',[.84 .07 .14 .16],'backgroundcolor','y');

helpbut = uicontrol('style','push','units','normal','pos',[.85 .18 .12 .04], ...
        'string','HELP','fontweight','bold','fontsize',14,...
        'call','set(gcf,''visible'',''off'');clc,help gsprac3,disp(cont),pause,set(gcf,''visible'',''on'');');

restbut = uicontrol('style','push','units','normal','pos',[.85 .13 .12 .04], ...
        'string','RESTART','fontweight','bold','fontsize',14,...
        'call','close(gcf),gsprac3');

quitbut = uicontrol('style','push','units','normal',...
          'pos',[.85 .08 .12 .04],'string','QUIT',...
          'fontweight','bold','fontsize',14,'call',done);


%INTRO
eval(showvecs)
eval(pltorig)

%solving so we have the answers
Aorth=gschmidt(A,1);
Aornorm=gschmidt(A);

%Step #1 of GS
subplot(messsub)
ml1=text(.05,.9,s3,'color','k','fontweight','bold','fontsize',14);
pause(1)
ml2=text(.05,.5,s4,'color','b','fontweight','bold','fontsize',14);
subplot(infosub)
text(0,.99,'Step #1','color','k','fontweight','bold','fontsize',14);
text(0,.9,'v1 = q1 = ','color','b','fontweight','bold','fontsize',14);
text(.33,.97,mat2strh(q1(1)),'color','b','fontweight','bold','fontsize',14);
text(.33,.90,mat2strh(q1(2)),'color','b','fontweight','bold','fontsize',14);
text(.33,.83,mat2strh(q1(3)),'color','b','fontweight','bold','fontsize',14);

pause(1)

subplot(messsub)
ml3=text(.05,.1,cont1,'color','k','fontweight','bold','fontsize',14);
pause,delete(ml1),delete(ml2),delete(ml3)

%step #2 of GS
subplot(messsub)
ml1=text(.05,.9,s5,'color','k','fontweight','bold','fontsize',14);
ml2=text(.05,.7,s6,'color','k','fontweight','bold','fontsize',14);
ml3=text(.05,.5,s7,'color','k','fontweight','bold','fontsize',14);


subplot(infosub)
text(0,.75,'Step #2','color','k','fontweight','bold','fontsize',14);
v2disp=text(0,.65,'v2 = q2 - (a number)*v1','color','m',...
                  'fontweight','bold','fontsize',14);

subplot(messsub)
ml4=text(.05,.1,cont1,'color','k','fontweight','bold','fontsize',14);
pause,delete(ml1),delete(ml2),delete(ml3),delete(ml4)



eval(showc1mess)

%insert editable text for coeff.

eval(entrybox)
