%                                               <<last updated 1/25/98>>
%PMDEMO   Graphical demonstration of convergence of approximate
%         eigenvectors generated by the scaled power method.
%         The matrix A can be 2 by 2 or 3 by 3 and must be real.
%         The column u is an initial guess for an eigenvector
%         associated with the dominant eigenvalue of A.
%         Sets of approximate eigenvectors are plotted on
%         the same set of axes.
%
%  Use in the form  ===>  pmdemo  <===
%                 
%  This routine calls pmdemo2 or pmdemo3 based upon the size the matrix.
%
%  By: David R. Hill, Math Dept, Temple University,
%      Philadelphia, Pa. 19122   Email: dhill001@temple.edu

%strings
s0=' ';
s1='Your choice --> ';
cont='Press ENTER to continue.';
head=[blanks(30) 'PMDEMO'];
head1='A graphical demonstration of the power method.';
menu=['              OPTIONS                 ';
      '                                      ';
      '<1> Power method with a 2 by 2 matrix.';
      '                                      ';
      '<2> Power method with a 3 by 3 matrix.';
      '                                      ';
      '<0> Quit.                             '];

gdsize='N';
while gdsize=='N'
      clc,disp(head),disp(s0),disp(head1),disp(s0)
      disp(menu),disp(s0)
      chsize=input(s1);
      if chsize==0,clc,disp('PMDEMO is over!'),return,end
      if chsize==1,gdsize='Y';pmdemo2,end
      if chsize==2,gdsize='Y';pmdemo3,end
      if gdsize=='N'
         disp(s0),disp('Improper choice; try again.')
         disp(s0),disp(cont)
         pause
      end
end


