function pic=scan(A,tol)               %last updated 11/15/01
%SCAN  Scans input matrix A element-by-element to generate an
%      image matrix pic consisting of blanks and X's. If there
%      is only one argument, tol is set to .5 and the rule
%
%      if A(i,j) > tol then pic(i,j)= X or block
%                      else pic(i,j) = blank
%
%      is used for image generation.
%   Use in the form ==>  pic = scan(A)  <==
%                or ==>  pic = scan(A,tol)  <==
%
%   WARNING: For proper display the command window font used must
%            be a fixed width font. Try fixedsys font or courier new.
%
%  By: David R. Hill, MATH Department, Temple University,
%      Philadelphia, Pa. 19122         Email: dhill001@temple.edu


%blk=eval('char(127)');   
blk='X'; %works well with courier new
[m,n]=size(A);
if nargin==1,tol=.5;end
for i=1:m
   pic(i,1:n)=blanks(n);
end
for i=1:m
   for j=1:n
      if A(i,j)>.5
         pic(i,j)=blk;
      end
   end
end
